'''
Created on 28 mai 2018

@author: chengrui
'''
from flask import Flask, Response, render_template, json, request
import os
import sys
import nn1.api.run as nn
import cirpy
import re
import shutil
import json
from chem_gm.core.metamolecule import MetaMolecule as MM

# indigo_path = '/Users/ouebsigma/anaconda3/lib/python3.6/site-packages/indigo-python-1.3.0beta.r0'
#indigo_path = '/Users/ouebsigma/anaconda3/lib/python3.6/site-packages/indigo'
indigo_path = '/Users/jeanluc/anaconda/envs/py36/lib/python3.6/site-packages/indigo'
sys.path.append(indigo_path)
from indigo import Indigo 
import indigo_renderer as ir

root = os.path.dirname(__file__)
# root = "/Users/chengrui/PycharmProjects/web_demo/"
#root = "/Users/ouebsigma/web_demo/"
#root = "/Users/jeanluc/Documents/Workspace/N1_API/src/nn1/api"
# .nnx

#model_c = os.path.join(root, "static", "GM_B13C4606_400T_0I_150E_10S_SEED3600643884_15N.nnx")
#model_c = os.path.join(root, "static", "GM_B13C4606_250T_0I_150E_10S_SEED3558649974_14N.nnx")
#model_c = os.path.join(root, "static", "GM_B13C4612_250T_0I_150E_10S_SEED2718355555_12N.nnx")
model_c = os.path.join(root, "static", "GM_B13C4535_250T_0I_150E_25S_SEED1218709802_10N.nnx")
model_h = os.path.join(root, "static", "GM_BromoListe0_250T_0I_150E_10S_SEED808053156_8N.nnx")
compound_name = "3-bromo-4-methoxybenzonitrile"

def select_smiles(smiles, com_name, nmr_kind='c'):
    return_list = []
    return_list_h = []
    if smiles and smiles != 'not in the cirpy, check manually':
        molecule = MM(smiles)
        list_eq = molecule.equivalentList()
        indigo = Indigo()

        for eq in list_eq:
            compound_no = eq[0]
            atom = molecule[compound_no]
            if atom.symbol == "C" and atom.aromatic:
                n_smiles = molecule.toSmiles(special=[[compound_no, 1]])
                p = len(return_list) // 2
                return_list.append(n_smiles)

                if atom.grade == 3:
                    n_smiles_h, _num = re.subn(re.compile('\[c:1\]'), 'c([H:1])', n_smiles)
                    return_list.append(n_smiles_h)
                    indigoRenderer = ir.IndigoRenderer(indigo)
                    mol_indigo = indigo.loadMolecule(n_smiles_h)  # indigo object
                    # mol_indigo.addDataSGroup([compound_no], [], "color", "1, 0, 0")

                    # indigo.setOption("render-atom-color-property", "color")
                    # indigo.setOption('render-coloring', False)
                    # indigo.setOption("render-comment", com_name + str(p))
                    # indigo.setOption("render-comment-font-size", 15)

                    # indigo.setOption("render-bond-length", 40)
                    indigo.setOption("render-image-size", 150, 90)
                    # indigo.setOption("render-margins", 30, 1)
                    # indigo.setOption("render-hdc-offset", "20, -50")
                    indigo.setOption("render-image-max-height", 120)
                    tg = os.path.join(root, 'static', 'temp_img', com_name)
                    imagename = "{0}{1}.png".format(tg, p)
                    indigoRenderer.renderToFile(mol_indigo, imagename)

                else:
                    indigo = Indigo()
                    return_list.append(None)
                    indigoRenderer = ir.IndigoRenderer(indigo)
                    mol_indigo = indigo.loadMolecule(smiles)  # indigo object
                    mol_indigo.addDataSGroup([compound_no], [], "color", "1, 0, 0")

                    indigo.setOption("render-atom-color-property", "color")
                    indigo.setOption('render-coloring', False)
                    # indigo.setOption("render-comment", com_name + str(p))
                    # indigo.setOption("render-comment-font-size", 15)

                    # indigo.setOption("render-bond-length", 40)
                    indigo.setOption("render-image-size", 150, 90)
                    # indigo.setOption("render-margins", 30, 1)
                    # indigo.setOption("render-hdc-offset", "20, -50")
                    indigo.setOption("render-image-max-height", 120)
                    tg = os.path.join(root, 'static', 'temp_img', com_name)
                    imagename = "{0}{1}.png".format(tg, p)
                    indigoRenderer.renderToFile(mol_indigo, imagename)
#                 p += 1
#     resutl = []
#     for val1, val2 in zip(return_list, return_list_h ):
#         resutl.append(val1)
#         result.append(val2)
    return return_list
#     return [(val1, val2) for val1, val2 in zip(return_list, return_list_h )]
#     return return_list, return_list_h


def get_results(selected_smiles, selected_smiles_h, comp_name): 

    load_c_model = nn.get_model(model_c, comp_name, selected_smiles)
    result = nn.get_result(load_c_model, level=1)
    if selected_smiles_h is not None:
        load_h_model = nn.get_model(model_h, comp_name, selected_smiles_h)
        result_h = nn.get_result(load_h_model, level=1)
        return [selected_smiles, result, result_h]
    else:
        return [selected_smiles, result, (0, 0, 0)]
    
# def get_result_c(selected_smiles, comp_name):
#     load_c_model = nn.get_model(model_c, comp_name, selected_smiles)
#     result = nn.get_result(load_c_model, level=1)
#     return selected_smiles, result

def get_result_single(selected_smiles, comp_name, source_list, source_index):
    result = None
    if selected_smiles is not None:
        model_source = source_list[source_index]
        load_h_model = nn.get_model(model_source, comp_name, selected_smiles)
        result = nn.get_result(load_h_model, level=1)
    return selected_smiles, result

def main(input_info, nmr_kind='c'):
    comp_smiles = cirpy.resolve(input_info, 'smiles')
    comp_name = cirpy.resolve(comp_smiles, 'iupac_name')
    comp_name = comp_name.replace(' ', '_')
    smiles_all = select_smiles(comp_smiles, comp_name)
#     smiles_list, smiles_list_h = select_smiles(comp_smiles, comp_name)
#     smiles_all = [(val1, val2) for val1, val2 in zip(smiles_list, smiles_list_h )]

#    return_list0 = []
    return_list = []
    lst = []
#    resold = None
    source_list = [model_c, model_h]
    model_list_c = []
    model_list_h = []
    for ind, smiles in enumerate(smiles_all):
        source_index = ind % 2
        if not source_index:
            model_list_c.append((source_list[source_index], comp_name, smiles))
        else:
            model_list_h.append((source_list[source_index], comp_name, smiles))
        # lst.append(get_result_single(smiles, comp_name, source_list, source_index))
    res_h = nn.get_results_from_smiles(model_list_h, level=1, parallel=True)
    res_c = nn.get_results_from_smiles(model_list_c, level=1, parallel=True)
    for smiles, (_, resc), (_, resh) in zip(smiles_all, res_c, res_h):
        selected_smiles = smiles
        result = [selected_smiles, resc, resh]
        return_list.append(result)
    
#     for ind, (smiles, (_, res)) in enumerate(zip(smiles_all, res_c, res_h)):
#         if not ind % 2:
#             selected_smiles = smiles
#             resc = res
#         else:
#             resh = res
#             if smiles is None:
#                 resh = (0, 0, 0)
#             result = [selected_smiles, resc, resh]
#             return_list.append(result)
            
#     for ind, val in enumerate(smiles_all):
#         if not ind % 2:
#             smiles = val
#         else:
#             smilesh = val
#             return_list.append(get_results(smiles, smilesh, comp_name))
#     
#     for smiles, smilesh in smiles_all:
#         return_list.append(get_results(smiles, smilesh, comp_name))
    
    return return_list, comp_name


app = Flask(__name__)
app.config.from_object(__name__)


@app.route('/index')
def hello_world():
    return 'Hello World!'


@app.route('/result', methods=['GET', 'POST'])
def jsme_result():
    try:
        tg = os.path.join(root, 'static', 'temp_img')
        try:
            shutil.rmtree(tg)
        except FileNotFoundError:
            pass
        try:
            os.makedirs(tg)
        except OSError: 
            pass
        compound_info = request.form.get('smiles')

        result_list, com_name = main(compound_info)

        tg1 = os.path.join('..', 'static', 'temp_img', com_name)
        posts = []
        for i, carbon in enumerate(result_list):
            p2j = {}
            p2j['c_smiles'] = carbon[0]
            min_ave_max = carbon[1]
            min_ave_max_h = carbon[2]
            p2j['mini'] = round(min_ave_max[0], 2)
            p2j['aver'] = round(min_ave_max[1], 2)
            p2j['maxi'] = round(min_ave_max[2], 2)
            p2j['mini_h'] = round(min_ave_max_h[0], 2)
            p2j['aver_h'] = round(min_ave_max_h[1], 2)
            p2j['maxi_h'] = round(min_ave_max_h[2], 2) 
            p2j['img_dir'] = '%s%s.png' % (tg1, i)
            posts.append(p2j)
        # print(posts)

        user = {'username': com_name}
        # posts = [
        #     {
        #         'author': {'username': 'John'},
        #         'body': 'Beautiful day in Portland!'
        #     },
        #     {
        #         'author': {'username': 'Susan'},
        #         'body': 'The Avengers movie was so cool!'
        #     }
        # ]
        return render_template('result.html', title='Home', user=user, posts=posts)
    except:
        raise
        return 'Sorry! The server is not responding, please try again later! ' \
               'Please be sure the structure you submitted is not empty and is aromatic'

# @app.route("/", methods=['POST'])
# def get_data():
#     data = json.loads(request.form.get('smiles'))
#     print(data)
#     return render_template('result.html')


@app.route("/", methods=['GET'])
def jsme():

    return render_template('JSME_NEW.html')


if __name__ == '__main__':
    # app.run(debug=True)
    app.run(host='0.0.0.0', port=5001, debug=True)
#    app.run(host='192.168.6.137', port=5000, debug=True)
