# -*- coding: UTF-8 -*-
#-------------------------------------------------------------------------------
# $Id$
#
# Copyright 2016 Jean-Luc PLOIX
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#-------------------------------------------------------------------------------
#from builtins import True
'''
Created on 28 sept. 2017

@author: jeanluc
'''

import os, sys, re
from six import text_type, print_
# from colorama import Fore, Style
#import sqlite3 as sql
from sqlite3 import connect as sqlconnect, Connection as sqlConnection, \
    PARSE_DECLTYPES as sqlPARSE_DECLTYPES, \
    OperationalError as sqlOperationalError
import functools as ft
import shutil
from collections import OrderedDict
from random import choice
from string import ascii_uppercase
from pandas import DataFrame, ExcelWriter
import numpy as np
from numpy import dot as npdot, random as rnd, sqrt
#try:
from concurrent.futures import as_completed, ProcessPoolExecutor as PoolExec
#except: pass

#from six import text_type
from nntoolbox.progress import FanWait, Progress_tqdm
from nntoolbox.modelutils import TransferModel, getModelDictFromConfig, \
    getGmxFileAndSave, tableTemplate, stdTable, roffTestStr, \
    paramStartStr, paramEndStr, dispStr, epochsStr
from nntoolbox.configparsertoolbox import defaultedConfigParser, \
    getDefaultedConfigParser
from nntoolbox.filetoolbox import decorfile, IndexFilename, \
    getDictFromGmx, removemodule, nnxReadError  #getReducedSelectedGmx,
from nntoolbox.utils import RE_NONE, RE_LOO, RE_SUPER,\
    DEMO_DEBUG_ANALYSIS, DEMO_DEBUG_PROGRESS, DEMO_DEBUG_MODEL, \
    DEMO_DEBUG_DISPLAY_1, DEMO_USAGE_NO_LIB, DEMO_DEBUG_USAGE, \
    DEMO_USE_EXISTING, DEMO_DEBUG_TRANSFER, DEMO_DEBUG_COST, DEMO_DEBUG_PRESS, \
    DEMO_DEBUG_JACOBIAN, DEMO_DEBUG_PARALLEL, DEMO_DEBUG_FOLDER
from nntoolbox.utils import getSqlFileNameFromConf, callerstr, hasOneOf, \
    float_format, IDformat, roundoff_format, getListFromStr, isIntList, \
    doNothing, splitvarunit, strintlist, isFloat, callerView, \
    get_decimal_size
from nntoolbox.excelutils import multiRangesType, simpleRangeType,\
    initiateExcelWriter, enrichRecapExcelFile, enrichUsageSheet
from nntoolbox.sqlite_numpy import createTableDb, cleanTableDb, getDataFrame, \
    getTableCountFromDb, getTableListFromDb

from monal.util.sqlite_copy_db import copy_table
from monal.modelutils import loadModule
from monal import __version__ as monalversion, monalconst as C
#from monal.datareader.datas ource import DataS ource
#from nnToolbox.excelutils import multiRangesType
from monal.datareader.fileInspect import inspectFile
from monal.util.toolbox import _linkstr, \
    make_dir, maxWorkers, toPrint  #, orderedIndexes
from monal.util.utils import appdatadir, getapplidatabase, libExtension
from monal.util.monaltoolbox import choiceQuestion, valueQuestion, \
    yesNoQuestion
#from monal.util.lineartoolbox import randomProbe
from monal.monalrecords import ModelData
from monal.model import Network, ModelLib
from monal.library.libmanager import moduleType
from monal.driver import onSpecialResult, Driver, DriverLib, DriverMultiDyn, \
    onEndIter, onReturnResult, DriverLib

from monal import version
from monal.datareader.excelsource import getFrame, gettitles, \
    getcustomproperty, getcustomproperties, getFrameFromExcel
from monal.library.libmanager import LibManager
from chem_gm.core import gmprograms as gmp
from chem_gm.core.gmtoolbox import getModelBase, updateConfigFromConfigstr
from chem_gm.components.gmmEngine import computeSmile
import chem_gm
GMpath = chem_gm.__path__[0]

from nn1 import __version__ as nn1_gmversion
applidatapath = getapplidatabase("nn1")
#defaultworkingdir = os.path.join(applidatapath, "demo")
externalshare = os.path.expanduser('~/docker')
externalresult = os.path.join(externalshare, 'result')
internalshare = '/home'
internalresult = os.path.join(internalshare, 'result')
internaldata = os.path.join(internalshare, 'data')
internalargsdir = os.path.join(internalshare, 'argsdir')

nobarverb = 3

USE_GM_LIB = 0

debug = 0
debugfolder = 0
debugAnalyse = 0
debugprogress = 0
debugModel = 0
debugDisplay = 0
debugTransfer = 0
debugJacobian = 0
debugCost = 0
debugPRESS = 0
debugParallel = 0
skipCreateModel = 0
debugUsage = 1

demodebug = 0
if debug:
    if debugAnalyse:
        demodebug = demodebug | DEMO_DEBUG_ANALYSIS
    if debugfolder:
        demodebug = demodebug | DEMO_DEBUG_FOLDER
    if debugprogress:
        demodebug = demodebug | DEMO_DEBUG_PROGRESS
    if debugModel:
        demodebug = demodebug | DEMO_DEBUG_MODEL
    if skipCreateModel:
        demodebug = demodebug | DEMO_USE_EXISTING
    if debugDisplay:
        demodebug = demodebug | DEMO_DEBUG_DISPLAY_1
    if debugTransfer:
        demodebug = demodebug | DEMO_DEBUG_TRANSFER
    if debugJacobian:
        demodebug = demodebug | DEMO_DEBUG_JACOBIAN
    if debugCost:
        demodebug = demodebug | DEMO_DEBUG_COST
    if debugPRESS:
        demodebug = demodebug | DEMO_DEBUG_PRESS
    if debugParallel:
        demodebug = demodebug | DEMO_DEBUG_PARALLEL
    if debugUsage:
        demodebug = demodebug | DEMO_DEBUG_USAGE

USE_NO_LIB = 2
NO_PARALLEL_TEST = 0

basicDecorDict = {
        'B': 'bootstrap',
        'b': 'bootstrap',
        'C': 'confstr',
        'c': 'confstr',
        'E': epochsStr,
        'e': epochsStr,
        'H': 'hash',
        'h': 'hash',
        'L': 'loo',
        'l': 'loo',
        'LT': 'levthresh',
        'lt': 'levthresh',
        'M': 'selectedcount', # pour compatibilite ascendante
        'm': 'selectedcount', # pour compatibilite ascendante 
        'N': 'hidden', 
        'n': 'hidden', 
        'S': 'selectedcount', 
        's': 'selectedcount', 
        'SE': 'seed',
        'se': 'seed',
        'SS': 'selectedcountex', 
        'ss': 'selectedcountex', 
        'T': 'traincount', 
        't': 'traincount', 
        'i': 'inputs',
        'm': 'mode',
        }

reverseDecorDict = {
    'mode': 'm',
    'inputs': 'i',
    'i': 'i',
    'traincount':'t',
    't': 't',
    'seed': 'se',
    'se': 'se',
    'selectedcount': 's',
    's': 's',
    'hidden': 'n',
    'n': 'n',
    'levthresh': 'lt',
    'loo': 'l',
    'l': 'l',
    'hash': 'h',
    'h': 'h',
    epochsStr: 'e',
    'e': 'e',
    'confstr': 'c',
    'c': 'c',
    'bootstrap': 'b',
    'b': 'b',
    }

groupavailables = {
        'identifiers': 0,
#        'smiles': 1,
        'inputs': 2,
        'outputs': 3,
    }

targetstr = "measured"  
leveragestr = "leverages"
pressstr = "VLOO score"
stddevstr = "RMSE"
stddevbiaslessstr = "biasless RMSE"
trainresidualstr = "estimation_error"
testresidualstr = "estimation_error"
estimatedstr = "estimated"
meanstr = "mean"

class monalError(Exception):
    pass

def currentshare(caller):
    if caller:
        return internalshare
    return externalshare

def updateOptionsFromGmx(options, sourcefile):
    if not os.path.exists(sourcefile):
        return
    dico = None
    try:
        dico = getDictFromGmx(sourcefile)
    except nnxReadError as err:
        try:
            dicoxl = getcustomproperties(sourcefile, "Utilities")
            if "Model file" in dicoxl.keys():
                nnxfile = dicoxl["Model file"]
                dico = getDictFromGmx(nnxfile)
            else:
                pass  # mettre ici la recherche de donnees interessantes dans le dicoxl lui-meme
        except:
            dico = None
    if dico is None:
        return -1
    if epochsStr in dico.keys():
        options.epochs = int(dico[epochsStr])
    if 'model' in dico.keys():
        modeldict = dico['model']
        if 'hidden' in modeldict.keys():
            options.hidden = int(modeldict['hidden'])
    if 'training' in dico.keys():
        traindict = dico['training']
        if epochsStr in traindict.keys():
            options.epochs = int(traindict[epochsStr])
        if 'initcount' in traindict.keys():
            options.initcount = int(traindict['initcount'])
        if 'initstddev' in traindict.keys():
            options.initstddev = float(traindict['initstddev'])
        if 'seed' in traindict.keys():
            options.seed = int(traindict['seed'])
    

def getDataFileInDocker(filename):
    if not filename:
        return ""#, True
    if os.path.exists(filename):
        return filename#, True
    test = os.path.join(internaldata, filename)    
    if os.path.exists(test):  
        return test#1, True
    test = os.path.join("~/home/data", filename) 
    test = os.path.expanduser(test)   
    if os.path.exists(test):  
        return test#1, True
    ppath = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
    pathlst = ["/data",
               os.path.join(ppath, "api", "demofiles"),
               os.path.join(GMpath, "api", "demofiles"),
               os.path.join(applidatapath, "demofiles"),
               os.path.abspath(os.path.join(GMpath, "..", "test", "testfiles"))]
    for curpath in pathlst:
        test = os.path.join(curpath, filename)    
        if os.path.exists(test):  
            return test#, False
    return ""#, False      
 
# # decorator for initiate sqlconnect
def connectMgr(func):
    """Decorator for sql connected functions.
    If function first parameter is a sql connection, then return the original function.
    Otherwise, if first parameter is a filename of a db registry, the connection 
    to this registry is open, then the original function is called with this connection as first parameter, and then the connection is closed.
    """
    from functools import wraps
    @wraps(func)
    def inside_func(*args, **kwargs):
        if not isinstance(args[0], str):
            return func(*args, **kwargs)
        with sqlconnect(args[0], detect_types=sqlPARSE_DECLTYPES) as dbConnect:
            res = func(dbConnect , *args[1:], **kwargs)
        return res
    return inside_func
     
@connectMgr
def getInitList(dbConnect, options, indexhead=0):
    initlist = []
    fieldlist = ["ID", "prevID", paramStartStr, paramEndStr, dispStr, roffTestStr]
    frameLoc = getDataFrame(dbConnect, table=stdTable, index=None,  
        fieldlist=fieldlist, comp=0, maxrec=options.maxrec, extraselect=options.extraselect, 
        orderfield="PRESS", reverse=False, substitute=C.SUBSTITUTE_FIELD)
    initlist = [tuple(frameLoc.ix[index]) for index in range(frameLoc.shape[0])]
    return initlist
    
@connectMgr
def getLOOFrame(dbConnect, options, sourceFrame):
    datacount = sourceFrame.shape[0]
    sourceindex = sourceFrame.index
    pptyname = options.propertyName
    fielddict = {
        'out': "LOO_{0}_{{0}}".format(pptyname),
        "StdDev" : "LOO_{0}_RMSE_{{0}}".format(pptyname), 
        "PRESS": "LOO_{0}_VLOO_{{0}}".format(pptyname), 
        "leverages": "LOO_{0}_Leverage_{{0}}".format(pptyname)
        }
    meanField = "LOO_mean_{0}".format(pptyname)
    maxrec = min(options.loomaxrec, options.looinitcount)  # ici ici ici
    fieldlist = ['out', "leverages", "StdDev", "PRESS"]
    if options.verbosexls >= 1:
        loowidth = 4
    else:
        loowidth = 2
    fieldlist = fieldlist[:max(2, loowidth)]
    extraselect = options.extraselect
    selectOnlev = options.looleveragethreshold > 0
    template = tableTemplate['loo']
    if options.looinittype != 2:
        extraselect = ""
    elif selectOnlev:
        levselect = "(leverages < {0})".format(options.looleveragethreshold)
        extraselect = "({0} AND {1})".format(extraselect, levselect)
    cols = [meanField] 
    for index in range(maxrec):
        locfieldlist = [fielddict[val].format(index) for val in fieldlist]
        cols.extend(locfieldlist)
    fullcol = list(sourceFrame) + cols
    newcol = OrderedDict({val: float('nan') for val in cols})
    looFrame = sourceFrame.assign(**newcol)  
    looFrame = looFrame[fullcol]      
    for molindex, molname in enumerate(sourceindex):
        # pour chaque molecule, on selectionne la liste des entrainement LOO
        cumul = 0
        rescount = 0
        table = template % molindex
        # On recherche les 'loomaxrec' premiers apprentissage par ordre de VLOO score croissant
        # rappel extraselect = "((DeltaRank = 0) AND (abs(RoundOffTest) < options.roundthreshold) )" 
        # et si selectOnlev est vrai, on ajoute la contrainte "(leverages < options.looleveragethreshold)"
            
        frameloc = getDataFrame(dbConnect, table, fieldlist=fieldlist, 
            orderfield="PRESS", extraselect=extraselect, maxrec=maxrec) 
        # le shape de frameloc est (loomaxrec, loowidth)
        cumul = 0.0
        if frameloc.shape[0]:
            # il y a des enregistrements qui repondent aux criteres definis par extraselect
            for indloc, row in frameloc.iterrows():
                cumul += row['out']
                for field, val in row.items():
                    fieldname = fielddict[field].format(indloc)
                    looFrame.at[molname, fieldname] = val
            looFrame.at[molname, meanField] = cumul / frameloc.shape[0]
        # Fin de la boucle sur les data
    return looFrame, len(fieldlist)

def _CheckTrainingParameters(options, doprint=None, verbose=1, forceyes=False, prefix=""):
    if isinstance(options.multihidden, list) and len(options.multihidden) > 1:
        hiddendefault = ",".join([str(val) for val in options.multihidden])
    else:
        hiddendefault = str(options.hidden)
    options.hidden = valueQuestion("Enter number of hidden neurons", 
        hiddendefault, "Hidden neurons", doprint=doprint, returnType=str,
        verbose=verbose, forcedefault=forceyes, prefix=prefix)
    options.multihidden = getListFromStr(options.hidden)
    if not isIntList(options.multihidden, True):
        raise ValueError("'{0}' is not a correct hidden value".format(options.hidden))        
    options.initcount = valueQuestion("Enter the number of training run", 
        options.initcount, "Training count", forcedefault=forceyes, 
        prefix=prefix, doprint=doprint,
        verbose=verbose)  
    options.epochs = valueQuestion("Enter the number epochs per run", 
        options.epochs, "Epochs", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose) 
    defaultmaxrec = ",".join([str(val) for val in sorted(options.multimaxrec)])
    options.maxrec = valueQuestion("Enter the training use count(s)",
        defaultmaxrec, "Training use count", forcedefault=forceyes, prefix=prefix, 
        returnType=str, doprint=doprint, verbose=verbose)
    options.multimaxrec = getListFromStr(options.maxrec)
    if not isIntList(options.multimaxrec, True):
        raise ValueError("'{0}' is not a correct training use value".format(options.maxrec))        
    options.seed = valueQuestion("Enter a random seed (-1 for no seed)", 
        options.seed, "Seed", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose, returnType=int)
    options.initstddev = valueQuestion("Enter random weights initialization standard deviation", 
        options.initstddev, "Envelope", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose, returnType=float)
    options.roundthreshold = valueQuestion("Enter computing error threshold", 
        options.roundthreshold, "Computing error threshold", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose, returnType=float)
    options.leveragethreshold = valueQuestion("Enter leverage selection threshold", 
        options.leveragethreshold, "Leverage threshold", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose, returnType=float)
    if isinstance(options.decor, str):
        defaultdecor = options.decor
    else:
        defaultdecor = ",".join([str(reverseDecorDict[val]) for val in options.decor])
    lst = ["Enter the file decoration choice list (comma separated)."]
    lst.append("Available decorators:")
    lst.append("\tt (traincount)")
    lst.append("\ti (inputcount)")
    lst.append("\te (epochs)")
    lst.append("\ts (selectedcount)")
    lst.append("\tse (seed)")
    lst.append("\tlt (leverage threshold)")
    lst.append("\tb (bootstrap)")
    lst.append("\tl (LOO)")
#     lst.append("\tc (confstr)")
#     lst.append("\th (hash)")
#     lst.append("\tn (hidden)")
#     lst.append("\tss (selectedcountex)")
    lst.append("")
    mess = "\n".join(lst)
    options.decor = valueQuestion(mess, defaultdecor, "File decoration", 
        forcedefault=forceyes, prefix=prefix, returnType=str, 
        doprint=doprint, verbose=verbose)
    if isinstance(options.decor, str):
        options.decor = options.decor.split(",")
    options.decor = [val.strip() for val in options.decor]

def _CheckLOOParameters(options, doprint=None, verbose=1, forceyes=False, prefix=""):
    initlist = ["start weight", "end weight", "random"]
    options.looinittype = choiceQuestion("Enter the LOO weight initialization type", 
        initlist, options.looinittype, printMessage="LOO weight initialization ", 
        returnType=int, doprint=doprint, forcedefault=forceyes, 
        extradisplay=True, listindexed=True, verbose=verbose)
    options.looinitcount = valueQuestion("Enter the number of LOO initializations",
        options.looinitcount, "LOO initializations", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose)
    options.looepochs = valueQuestion("Enter the number of LOO epochs",
        options.looepochs, "LOO epochs", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose)
    options.loomaxrec = valueQuestion("Enter the LOO training use count",
        options.loomaxrec, "LOO training use count", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose)  

def _CheckBSParameters(options, doprint=None, verbose=1, forceyes=False, prefix=""):
    initlist = ["none", "standard", "residus"]
    options.bootstraptype = choiceQuestion("Enter the bootstrap type", 
        initlist, options.bootstraptype, printMessage="BS type ", 
        returnType=int, doprint=doprint, forcedefault=forceyes, 
        extradisplay=True, listindexed=True, verbose=verbose)
    initlist = ["start weight", "end weight", "random"]
    options.bootstrapinittype = choiceQuestion("Enter the bootstrap weight initialization type", 
        initlist, options.bootstrapinittype, printMessage="bootstrap weight initialization ", 
        returnType=int, doprint=doprint, forcedefault=forceyes, 
        extradisplay=True, listindexed=True, verbose=verbose)
    options.bootstrapinitcount = valueQuestion("Enter the number of bootstrap initializations",
        options.bootstrapinitcount, "Bootstrap initializations", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose)
    options.bootstrapepochs = valueQuestion("Enter the number of bootstrap epochs",
        options.bootstrapepochs, "Bootstrap epochs", forcedefault=forceyes, prefix=prefix, 
        doprint=doprint, verbose=verbose)

def _getBestWeights(dbConnect, options):
    table = options.datatable
    maxrec = options.maxrec 
    basedir = options.folder
    extraselect = options.extraselect 
    extraselectrelaxed = options.extraselectrelaxed 
    orderfield = options.orderfield
    verbose = options.verbosexls
    fieldlist = ['ID', 'param_end']
    resultFrame = getDataFrame(dbConnect, table=table, index="ID",
        fieldlist=fieldlist, comp=0, maxrec=1, 
        extraselect=extraselect, orderfield=orderfield, reverse=False, 
        substitute=C.SUBSTITUTE_FIELD)
    try:
        wgt = resultFrame['param_end'][0]
    except IndexError:
        wgt = None
    return wgt

def getResultFrame(dbConnect, options=None, resfile="", 
        table=stdTable, maxrec=10, basedir="", extraselect="", 
        orderfield="PRESS", verbosexls=0):
    
    if not options is None:
        table = options.datatable
        maxrec = options.maxrec 
        basedir = options.folder
        extraselect = options.extraselect 
        extraselectrelaxed = options.extraselectrelaxed 
        orderfield = options.orderfield
        verbosexls = options.verbosexls
    
    if not isinstance(dbConnect, sqlConnection):
        if resfile and isinstance(resfile, str):
            confResult = defaultedConfigParser(resfile)
            cfgfile = confResult.get(options.root, "cfgfile")
            if os.path.exists(cfgfile):
                confResult = defaultedConfigParser(cfgfile)
                root = confResult.get("projects", "0")
                savedir = os.path.join(basedir, root)
                if hasattr(options, "sqlFileName") and options.sqlFileName:
                    sqlFileName = options.sqlFileName
                else:
                    sqlFileName = confResult.get(root, "sqlfilename")
                dbConnect = sqlconnect(sqlFileName, detect_types=sqlPARSE_DECLTYPES)
                options.sqlFileName = sqlFileName
                options.modulename = confResult.get(root, "module")
                if demodebug & DEMO_DEBUG_USAGE:
                    print("sqlFileName", sqlFileName)
    if verbosexls >= 3:
        fieldlist = ["ID", "StdDev", "PRESS", 'roffTestStr', "DeltaRank", "R2", 
            "Determinant", "Conditionning",  "CorrelMean", 
            "EigenMin",  "EigenMax",  "Mu",  "Correl",  "CorrelMax",  
            "StdDevBiasless", "Trace", "Epochs", "Hidden", "seed"]  #, "AdjustedR2"
    elif verbosexls == 2:
        fieldlist = ["ID", "StdDev", "PRESS", "RoundOffTest", "DeltaRank", "seed"]
    elif verbosexls == 1:
        fieldlist = ["ID", "StdDev", "PRESS", "seed"]
    else:
        fieldlist = ["ID", "StdDev", "PRESS"]
        
    reverse = orderfield in C.TCR_MAXIMIZE 
    index = 'ID'  if 'ID' in  fieldlist else None
    resultFrame = getDataFrame(dbConnect, table=table, index=index,
        fieldlist=fieldlist, comp=0, maxrec=maxrec, 
        extraselect=extraselect, orderfield=orderfield, reverse=reverse, 
        substitute=C.SUBSTITUTE_FIELD)
    if 'ID' in resultFrame.columns:
        resultFrame.set_index('ID', inplace=True)
        
    return resultFrame

def apiTrainResults(options=None, resfile="", titles=[], targets=None, 
        maxrec=10, resultdisplay=-1, extraselect="", extraselectrelaxed="",
        outfile=sys.stdout, orderfield="PRESS", extratype="", gmxfile="",
        debug=0, verbose=1, verbosexls=0, trainDataFrame=None):
    
    IDlist = []
    if not options is None:
        titles = options.datatitles
        maxrec = options.maxrec 
        resultdisplay = options.resultdisplay 
        extraselect = options.extraselect 
        extraselectrelaxed = options.extraselectrelaxed
        outfile = options.outfile 
        debug=options.debug 
        verbose = options.verbose 
        verbosexls = options.verbosexls
        orderfield = options.orderfield
        resfile = options.cfgfile
        mode = options.mode
    doprint = toPrint(outfile)
    specialresultdisplay = -1 
    if (extratype == 'loo'):
        specialresultdisplay = options.loomaxrec
            
    if resfile and isinstance(resfile, str):
        confResult = defaultedConfigParser(resfile)
        confResult.read(resfile)
        if confResult.has_section("projects"):
            root = confResult.get("projects", "0")
        else:
            root = options.root
        if confResult.has_section(root) and confResult.has_option(root, "cfgfile"):
            cfgfile = confResult.get(root, "cfgfile")
            confResult = defaultedConfigParser(cfgfile)
        if hasattr(options, "sqlFileName") and options.sqlFileName:
            sqlFileName = options.sqlFileName
        else:
            sqlFileName = confResult.get(root, "sqlfilename")
        options.sqlFileName = sqlFileName
        tablename = confResult.get(root, "tablename")
        options.tablename= tablename
        pptyname = confResult.get(root, "propertyname")
        options.pptyname = pptyname
        pptyunit = confResult.get(root, "propertyunit")
        options.pptyunit = pptyunit
        module = confResult.get(root, "module")
        options.modulename = module
        gmxfile = confResult.get(root, "gmxfile")
#         if targets is None:
#             targetsstr = confResult.get(root, "targetlist")
#             targets = [float(val) for val in targetsstr.split(",")]
    else:
        root = options.root
        sqlFileName = options.sqlFileName
        tablename = options.tableName
        pptyname = options.propertyName
        pptyunit = options.propertyunit
        module = options.modulename
        fol = os.path.dirname(module) 
        if not fol:
            module = os.path.join(options.savedir, module)
    with sqlconnect(sqlFileName, detect_types=sqlPARSE_DECLTYPES) as dbConnect:
        reverse = orderfield in C.TCR_MAXIMIZE  
        curselect = extraselect 
        IDlist = getDataFrame(dbConnect, table=tablename, index=None, 
            fieldlist=["ID"], comp=0, orderfield=orderfield, reverse=reverse,
            maxrec=maxrec, extraselect=curselect)["ID"]
        if not IDlist.shape[0]:
            curselect = extraselectrelaxed
            IDlist = getDataFrame(dbConnect, table=tablename, index=None, 
                fieldlist=["ID"], comp=0, orderfield=orderfield, reverse=reverse,
                maxrec=maxrec, extraselect=curselect)["ID"]
        if options.notrain:
            model = None
            dataframe = getFrameFromExcel(options.origin, 'Training results', reduce=True)
        else:
            model = loadModule(module, pptyname=pptyname, targets=targets)
            model.loadTrainingData(options)
            if len(titles) and model.modelCount and 'identifiers' in options.grouplist:
                indexname = titles[0][0]
            else:
                indexname = None
            dataframe = _computeTrainingResult(dbConnect, tablename, model, 
                resultdisplay=resultdisplay, 
                specialresultdisplay=specialresultdisplay,
                IDlist=IDlist, 
                maxrec=maxrec, 
                targets=targets, 
                pptyname=pptyname, 
                extraselect=curselect,
                orderfield=orderfield, 
                indexname=indexname, 
                extratype=extratype, 
                verbosexls=verbosexls)
            if not dataframe.index.name:
                dataframe.index.name = trainDataFrame.index.name
    if (verbose >= 6) and (outfile is not None):
        doprint("Training data:")
        doprint(dataframe.to_string(float_format=float_format(verbose)))
    trainresultColumn = 1
    return dataframe, IDlist, root, model, trainresultColumn, gmxfile
    
def _apiDemoBS(config, options, resultFrame, sqlFileName, model):  #, resfile
    base, ext = os.path.splitext(sqlFileName)
    sqlBSFileName = "%s_BS%d_%dT_%dE_%dI%s"% (base, options.bootstraptype, 
        options.bootstrapcount, options.bootstrapepochs, 
        options.bootstrapinittype, ext)
    sqlBSFileName = IndexFilename(sqlBSFileName)
    #confResult = defaultedConfigParser(resfile)
    root = options.root
    #root = confResult.get("projects", "0")
    config.set(root, 'sqlbootstrapfilename', sqlBSFileName)
    pptyname = config.get(root, "propertyname")
    config.save(options.cfgfile)
    if model is None:
        model = LoadModuleFromCfg(config)
    else:
        gmxfile = config.get(root, "gmxfile")
        dico = getDictFromGmx(gmxfile)
        model.loadParameters(dico)
    trainFrame, IDlist, root, module = apiDemoReadBSTrainFrame(options, resfile)
    if trainFrame is None:
        nametitle, smilestitle, pptyname = "", "", "" #maintitles0      
    copy_table(sqlFileName, sqlBSFileName, stdTable)    
    dbConnect = sqlconnect(sqlBSFileName, detect_types=sqlPARSE_DECLTYPES)
    for ind in range(options.bootstrapcount):
        template = tableTemplate['bs']
        dict = C.EXTRA_TRAIN_DATA.copy()
        createTableDb(dbConnect, template % ind, dict) 
    initlist = getInitList(sqlFileName, options)
    onBSResultLoc = ft.partial(onSpecialResult, dbConnect, tableTemplate['bs'])
    with Progress_tqdm(options.bootstrapcount, desc='Bootstrap training', 
        nobar=options.verbose<nobarverb) as update:
        resamplingTrainModule(model,     
            inittype=options.bootstrapinittype, 
            initlist=initlist, 
            initcount=options.bootstrapinitcount, 
            epochs=options.bootstrapepochs, 
            BStype=options.bootstraptype, 
            count=options.bootstrapcount,
            weightsstddev=options.initstddev, 
            selected_LOO=None, 
            onReturnResult = onBSResultLoc,
            callBack=update,  #printTo(outfile), 
            LOOcriterion=-C.CRITER_PRESS)
    
    gm0 = getModelDictFromConfig(config)
    indexlist = IDlist
    extrasize = options.bootstrapcount
    gmxfileBS = getGmxFileAndSave(dbConnect, gm0, config, indexlist, options, extrasize=extrasize, dosave=True)  # ici gmx
    config.set(root, "gmxfile", gmxfileBS)
    config.save()

    model.extraweights = getExtraWeightsFromTable(dbConnect, 
                            tableTemplate['bs'], 
                            "PRESS", 
                            options.extraselect)
    bsFrame = apiDemoGetBSFrame(dbConnect, options, model)  
    
    dbConnect.close() 
    
    return model, bsFrame, gmxfileBS, sqlBSFileName, IDlist  #trainFrame

def _apiDemoLOO(config, options, sourceFrame, resultFrame, model, seed=None):
    sqlFileName = options.sqlFileName
    base, ext = os.path.splitext(sqlFileName)
    sqlLOOFileName = "%s_LOO_%dT_%dE_%dI%s"% (base, options.looinitcount, options.looepochs, options.looinittype, ext)
    sqlLOOFileName = IndexFilename(sqlLOOFileName)
    root = options.root
    config.set(root, 'sqlloofilename', sqlLOOFileName)
    options.sqlLOOFileName = sqlLOOFileName
    pptyname = config.get(root, "propertyname")
    config.save(options.cfgfile)
    if sourceFrame:
        trainFrame = sourceFrame._frame.copy()
        trainresultColumn = sourceFrame.shape[1]
#         IDlist = resultFrame['ID']
        IDlist = resultFrame.index
    else:
        trainFrame, IDlist, root, _, trainresultColumn, gmxfile = apiReadLOOTrainFrame(options)  #module
    if trainFrame is None:
        nametitle, smilestitle, pptyname = "", "", "" #maintitles0   
    copy_table(sqlFileName, sqlLOOFileName, stdTable)    
    
    with sqlconnect(sqlLOOFileName, detect_types=sqlPARSE_DECLTYPES) as dbConnect:
        for ind in range(model.dataCount):  # vérifier ici si baselen ne doit pas etre lu depuis config
            dict = C.EXTRA_TRAIN_DATA.copy()
            template = tableTemplate['loo']
            createTableDb(dbConnect, template% ind, dict) 
        
        initlist = getInitList(sqlFileName, options)
        onBSResultLoc = ft.partial(onSpecialResult, dbConnect, tableTemplate['loo'])
        with Progress_tqdm(model.dataCount, desc='LOO training', 
            nobar=options.verbose<nobarverb) as update:
            loccount, resultMatrix = resamplingTrainModule(model,     
                inittype=options.looinittype, 
                initlist=initlist, 
                initcount=options.looinitcount, 
                epochs=options.looepochs, 
                BStype=RE_LOO, 
                weightsstddev=options.initstddev, 
                selected_LOO=None, 
                onReturnResult = onBSResultLoc,
                callBack=update,
                LOOcriterion=-C.CRITER_PRESS,
                seed=seed)
        gm0 = getModelDictFromConfig(config)
        indexlist = list(IDlist)
        extrasize = model.dataCount 
        neurotype = 'nn1'
        gmxfileLOO = getGmxFileAndSave(dbConnect, gm0, config, None, options,  #indexlist, 
            neurotype, extrasize=extrasize, dosave=True)  # ici gmx
        config.set(root, "gmxfile", gmxfileLOO)
        config.save()
        datacount = max(model.modelCount, model.dataCount)
        if not datacount and not sourceFrame is None:
            datacount = sourceFrame.shape[0]
        trainresultColumn = trainFrame.shape[1]
        
        trainFrame, _ = getLOOFrame(dbConnect, options, trainFrame) 
    # end of dbConnect context 
    return model, trainFrame, gmxfileLOO, sqlLOOFileName, IDlist, trainresultColumn

def apiReadLOOTrainFrame(options):
    """Recupere le trainFrame avant le LOO
    """ 
    if not options.test:
        options.test = options.source
    try:
        row = gettitles(options.test, options.filetype, 
            datarange=options.testrange, datafmt=options.testfields)  #, titlesfirst=True)
        return  apiTrainResults(options, resfile=None, titles=row, extratype='loo')   #titles
    except Exception as err:
#        print()
        print(err)
        raise
        return None, None, "", ""
           
def LoadModuleFromCfg(cfgfile, modulename=""):
    """charge un module d'apprentissage depuis les informations de config
    Passe par l'intermediaire du fichier gmx.
    Charge egalement les cibles d'apprentissage.
    Le nom du module est facultatif. S'il est absent, il est recherche dans le 
    fichier cfg.
    Retourne le modele ainsi cree.
    """
    if isinstance(cfgfile, str):
        confResult = defaultedConfigParser(cfgfile)
        root = confResult.get("projects", "0")
        config = getDefaultedConfigParser(confResult.get(root, "cfgfile"))
    else:
        config = cfgfile
        root = config.get("projects", "0")
    if not modulename:
        modulename = config.get(root, "module")
    gmxfile = config.get(root, "gmxfile")
    dico = getDictFromGmx(gmxfile)
    model = loadmoduleloc(modulename)   #loadTrainingModule(modulename)
    model.loadParameters(dico)
    #model.targets = targetlist
    return model

def loadmoduleloc(modulename, workingdir=""):
    if not modulename.endswith((".dll", ".so", ".dylib")):
        return None
    if workingdir:
        modulename = os.path.join(workingdir, modulename)
    mtype = moduleType(modulename)
    if mtype == 3:
        return DriverLib(modulename)
    if mtype == 2:
        return DriverMultiDyn(modulename)
    if mtype == 1:
        return ModelLib(modulename)

def _loadTrainingResult(dbConnect, tablename, resultdisplay=-1,
        specialresultdisplay=-1, IDlist=[0], maxrec=10, targets=None, 
        pptyname="", extraselect="", orderfield="PRESS", indexname=None, 
        extratype="", verbosexls=1):
    """Lecture des résultats d'apprentissage.
    Les resultats d'apprentissage sont dans la base de donnees connectee par 
    dbConnect. 
    Creation de la table DataFrame.
    """
    targetfield = _linkstr(targetstr, pptyname)
    fieldlist = ["ID", paramEndStr]  #, "disp ersion"]
    resindex = IDlist[0]
    indlist = IDlist[:maxrec]
    if resultdisplay < 0:
        resultdisplay = len(indlist)
    else:
        resultdisplay = max(1, min(resultdisplay, len(indlist)))
    reverse = orderfield in C.TCR_MAXIMIZE   
    paramdisp = getDataFrame(dbConnect, table=tablename, fieldlist=fieldlist, 
        comp=0, maxrec=maxrec, orderfield=orderfield, reverse=reverse, 
        extraselect=extraselect)  #index=resindex, 
    
#     ww = paramdisp[paramEndStr]
#     weights = np.ndarray((ww.shape[0], ww[0].shape[0]))
#     for ind, w in enumerate(ww):
#         weights[ind] = w
#     ll = min(resultdisplay, ww.shape[0])
#     if extratype in ['loo', 'bootstrap']:
#         resultarray = np.ndarray((model.baseLen, 1 + ll))
#     else:
#         resultarray = np.ndarray((model.baseLen, 1 + 4 * ll))
#     
#     multires = TransferModel(model, weights=weights, style=2, debug=1)
    columns = [targetfield]
    for ind, besttrainindex in \
            zip(range(resultdisplay), paramdisp["ID"]):
        start = len(columns)
        if extratype in ['loo', 'bootstrap']:
            columns.append(_linkstr("VLOO", pptyname, besttrainindex))
        else:
            columns.extend([_linkstr(estimatedstr, pptyname, besttrainindex), 
                _linkstr(trainresidualstr, pptyname, besttrainindex), 
                _linkstr(leveragestr, pptyname, besttrainindex), 
                _linkstr("VLOO", pptyname, besttrainindex)])
    fieldlist
    df = getDataFrame(dbConnect, table=tablename, fieldlist=columns, 
        comp=0, maxrec=maxrec, orderfield=orderfield, reverse=reverse, 
        extraselect=extraselect)     
#         for ind, (target, residual, lev) in enumerate(zip(model.targets, 
#                 residuals, leverages)):  #, model.modelNames
#             #if start == 1:
#             if extratype in ['loo', 'bootstrap']:
#                 resultarray[ind, 0] = target
#                 resultarray[ind, start] = target + residual/(1 - lev)
#             else:    
#                 resultarray[ind, 0] = target
#                 resultarray[ind, start] = target + residual
#                 resultarray[ind, start + 1] = residual  # 3
#                 resultarray[ind, start + 2] = lev  # 2
#                 resultarray[ind, start + 3] = target + residual/(1 - lev)  # 1
#         
#     try:
#         model.modelNames[0]
#         index = model.modelNames
#     except (AttributeError, IndexError):
#         index = range(model.dataCount)
#     df = DataFrame(resultarray, columns=columns, index=index)
#     if indexname is not None:
#         df.index.name = indexname
    return df

def _computeTrainingResult(dbConnect, tablename, model, resultdisplay=-1,
        specialresultdisplay=-1, IDlist=[0], maxrec=10, targets=None, 
        pptyname="", extraselect="", orderfield="PRESS", indexname=None, 
        extratype="", verbosexls=1): 
    """Calcul des résultats d'apprentissage.
    Les resultats d'apprentissage sont dans la base de donnees connectee par 
    dbConnect. 
    Creation de la table DataFrame.
    """
    targetfield = _linkstr(targetstr, pptyname)
    internal = isinstance(model, str)
    if internal:
        model = loadModule(model, pptyname=pptyname, targets=targets)
    fieldlist = ["ID", paramEndStr]  #, "disp ersion"]
    resindex = IDlist[0]
    indlist = IDlist[:maxrec]
    if resultdisplay < 0:
        resultdisplay = len(indlist)
    else:
        resultdisplay = max(1, min(resultdisplay, len(indlist)))
    reverse = orderfield in C.TCR_MAXIMIZE   
    paramdisp = getDataFrame(dbConnect, table=tablename, fieldlist=fieldlist, 
        comp=0, maxrec=maxrec, orderfield=orderfield, reverse=reverse, 
        extraselect=extraselect)  #index=resindex, 
    
    ww = paramdisp[paramEndStr]
    weights = np.ndarray((ww.shape[0], ww[0].shape[0]))
    for ind, w in enumerate(ww):
        weights[ind] = w
    ll = min(resultdisplay, ww.shape[0])
    if extratype in ['loo', 'bootstrap']:
        resultarray = np.ndarray((model.baseLen, 1 + ll))
    else:
        resultarray = np.ndarray((model.baseLen, 1 + 4 * ll))
    
    multires = TransferModel(model, weights=weights, style=2, debug=1)
    columns = [targetfield]
    for ind, besttrainindex, (_, residuals, _, leverages, _, _, _) in \
            zip(range(resultdisplay), paramdisp["ID"], multires):
        start = len(columns)
        if extratype in ['loo', 'bootstrap']:
            columns.append(_linkstr("VLOO", pptyname, besttrainindex))
        else:
            columns.extend([_linkstr(estimatedstr, pptyname, besttrainindex), 
                _linkstr(trainresidualstr, pptyname, besttrainindex), 
                _linkstr(leveragestr, pptyname, besttrainindex), 
                _linkstr("VLOO", pptyname, besttrainindex)])
        
        for ind, (target, residual, lev) in enumerate(zip(model.targets, 
                residuals, leverages)):  #, model.modelNames
            #if start == 1:
            if extratype in ['loo', 'bootstrap']:
                resultarray[ind, 0] = target
                resultarray[ind, start] = target + residual/(1 - lev)
            else:    
                resultarray[ind, 0] = target
                resultarray[ind, start] = target + residual
                resultarray[ind, start + 1] = residual  # 3
                resultarray[ind, start + 2] = lev  # 2
                resultarray[ind, start + 3] = target + residual/(1 - lev)  # 1
        
    try:
        model.modelNames[0]
        index = model.modelNames
    except (AttributeError, IndexError):
        index = range(model.dataCount)
    df = DataFrame(resultarray, columns=columns, index=index)
    if indexname is not None:
        df.index.name = indexname

    if internal:
        model.__del__()

    return df

def apiTestResults(resfile, datacount=0, modeltestframe=None, 
        IDlist=[], options = None, testfile="", filetype="", testrange="", 
        testformat=None, maxreclist=[], basedir="", leveragethreshold=5, 
        resindex=0, extraselect="", orderfield="PRESS", outfile=sys.stdout,
        traintype="", verbose=1, verbosexls=0, todoprint=True, debug=0):
    gmxfile = ""
    testfile=options.test
    if not options is None:
        filetype=options.filetype 
        testrange=options.testrange 
        testformat=options.testfields
        maxreclist = options.multimaxrec
        basedir=options.folder 
        resindex=options.resultindex 
        leveragethreshold=options.leveragethreshold 
        extraselect=options.extraselect 
        outfile=options.outfile 
        verbose=options.verbose 
        verbosexls=options.verbosexls
        debug=options.debug
        orderfield = options.orderfield
    doprint = toPrint(outfile)
    testinputColumns = []
    useexistingmodels = (debug & DEMO_USE_EXISTING)
    confResult = None
    if not resfile or not isinstance(resfile, str):
        raise monalError("configuration data file is not correct")
    confResult = defaultedConfigParser(resfile)
    try:
        root = confResult.get("projects", "0")
    except Exception:  #NoSectionError
        root = options.root
        cfgfile = confResult.get(root, 'cfgfile')
        confResult = defaultedConfigParser(cfgfile)
    tablename = confResult.get(root, "tablename")
    pptyname = confResult.get(root, "propertyname")
    pptyunit = confResult.get(root, "propertyunit")
    if hasattr(options, "modelfile") and options.modelfile:
        gmxfile = options.modelfile
    else:
        gmxfile = confResult.get(root, "gmxfile")
    sqlFileName = getSqlFileNameFromConf(confResult, root, traintype)
    source = gmxfile
    
    if isinstance(source, text_type):
        source = getDictFromGmx(source)
    
    savedir = os.path.join(basedir, root)
    modulesource = confResult.get(root, "module")
    modulename = os.path.splitext(os.path.basename(modulesource))[0]
    inputcount = 0  
    if not len(IDlist) : 
        with sqlconnect(sqlFileName, detect_types=sqlPARSE_DECLTYPES) as dbConnect:
            reverse = orderfield in C.TCR_MAXIMIZE
            IDlist = getDataFrame(dbConnect, table=tablename, index=None, 
                fieldlist=["ID"], comp=0, orderfield=orderfield, reverse=reverse,
                maxrec=maxreclist[0], extraselect=extraselect)["ID"]
    if not traintype:
            testframe, patternlist, testFrameBaseCol, inputcount = \
            _computeTest(options, modeltestframe, IDlist, tablename, 
            pptyname, maxreclist, source, savedir, testfile, 
            filetype=filetype, 
            leveragethreshold=leveragethreshold, extraselect=extraselect, 
            orderfield=orderfield, verbose=verbose, debug=debug) 
    elif traintype == 'loo':
        testframe, patternlist, testFrameBaseCol = _computeLOOTest(
            options,  modeltestframe, 
            tablename, pptyname, datacount, source, savedir, 
            testfile, filetype=filetype, 
            testrange=testrange, testformat=testformat, 
            leveragethreshold=leveragethreshold, extraselect=extraselect, 
            orderfield=orderfield, verbose=verbose, debug=debug) 
    elif traintype in ['bs', 'bootstrap']:
        testframe, patternlist, testFrameBaseCol = _computeBSTest(
            options, modeltestframe, 
            tablename, pptyname, options.bootstrapcount, source, 
            savedir, testfile, filetype=filetype, 
            testrange=testrange, testformat=testformat, 
            leveragethreshold=leveragethreshold, extraselect=extraselect, 
            orderfield=orderfield, verbose=verbose, debug=debug)
        
    resultColumn = testFrameBaseCol + 2
    if inputcount:
        delta = testFrameBaseCol - inputcount
        testinputColumns = list(range(delta, testFrameBaseCol))

    if not verbosexls:  # reduction de dimension de la table pour affichage restreint
        for val in testframe.columns[resultColumn:]:
            testframe.drop(val, 1, inplace=True)
    # remplacement du nom de propriete par targetstr dans les champs de testFrame
    lst = list(testframe.columns)
    for ind, val in enumerate(testframe.columns):
        if val == pptyname or (val.startswith(pptyname) and val[len(pptyname)]=='('):
            lst[ind] = _linkstr(targetstr, pptyname)
            break
    testframe.columns = lst
    if (verbose >= 4) and (testframe is not None):  #and (out file is not None) 
        doprint("test data (leverage threshold = %s):" % leveragethreshold)
        doprint(testframe.to_string(float_format=float_format(verbose)))
#     elif (verbose >= 3) and todoprint:
#         doprint("leverage threshold = %s" % leveragethreshold)      
        
    # lire et afficher - le tableau des resultats, le digramme de dispersion du meilleur
#     if not blind:
#         figure = _drawResult(modulename, pptyname, dataframe, datarange, testframe, testrange, IDlist[resindex], pptyname)
    return testframe, patternlist, pptyname, testFrameBaseCol, gmxfile  #testinputColumns


def _checkGroupList(grlist, doprint=None, forceyes=False, verbose=1):
 
    extralist = [val for val in groupavailables if val not in grlist]
#     if len(extralist):
#         st = "group list is ({0}). you may add new items".format(",".join(grlist))
#         doprint(st, verbose=verbose)
    change = False
    for val in extralist:
        mess = "Will you have '{0}' data ?".format(val)
#         mess = "add '{0}' to the field group list?".format(val)
        printMessage = "adding '{0}'".format(val)
        accept = yesNoQuestion(mess, default="y", printMessage=printMessage, doprint=doprint, 
                outfile=None, forceyes=forceyes, verbose=verbose)
        if accept:
            change = True
            grlist.append(val)
    grlist.sort(key=lambda x:groupavailables[x])
    if change:
        st = "group list is now ({0})".format(",".join(grlist))
        doprint(st, verbose=verbose)
     
    return grlist
 
def _checkFile(filename, datafor='train', datarange="", indexdefault=0, forcedefault=False, 
        doprint=doNothing, verbose=1):
    ranges = []
    res = inspectFile(filename, forceTitles=True)
    ftype = res[0]
    if ftype in multiRangesType:
        rangeRichList = [val for val in res[1:] if not val[0].startswith('_')]
        ranges = [val[0] for val in rangeRichList]  
        if datarange in ranges:
            indexdefault = ranges.index(datarange)
        sizes = [val[1] for val in rangeRichList]
        titleslist = [val[3] for val in rangeRichList]
        promptlst = ['Availables ranges for {0}:'.format(datafor)]
        for ind, (value, size, titles) in enumerate(zip(ranges, sizes, titleslist)):
            if not value.startswith("_"):
                lst = ['\t', text_type(ind), str(value), '\tfields:', text_type(titles), '\t', text_type(size), 'lines']
                promptlst.append(" ".join(lst))
        promptlst.append("Please choose {0} source range by its index [{1}] ?".format(datafor, indexdefault))
        mess = "\n".join(promptlst)
        printMessage = "Chosen {0} range:".format(datafor)
        datarange = choiceQuestion(mess, ranges, indexdefault, printMessage, 
            returnType=str, doprint=doprint, forcedefault=forcedefault,
            verbose=verbose)
        if datarange is None:
            return ftype, None, None, None 
        titles = titleslist[ranges.index(datarange)]
    else:
        ftype, size, titleFirst, titles = res  
        promptlst = []
        promptlst.append('Availables for {0}:'.format(datafor))
        lst = ['\tfields:', str(titles), '\t', str(size), 'lines']
        promptlst.append(" ".join(lst))
        promptlst.append("Accept these data for {0} [y] ?".format(datafor))
        mess = "\n".join(promptlst)
        accept = yesNoQuestion(mess, default='y', printMessage="", 
            doprint=doprint, forceyes=forcedefault, verbose=verbose)
        if not accept:
            return ftype, None, None, None
    return ftype, datarange, titles, ranges

def _getfullmodelNNName(options, dataframe=None, savedir="", ext=None):
    if ext is None:
        ext = libExtension()
    if not savedir:
        savedir = options.savedir
    if dataframe:
        inputs = dataframe.fieldsOf('inputs')
        outputs = dataframe.fieldsOf('outputs')
    elif not options.notrain:
        inputs = options.datafields[options.grouplist.index('inputs')]
        outputs = options.datafields[options.grouplist.index('outputs')]
    else:
        inputs = options.testfields[options.grouplist.index('inputs')]
        outputs = options.testfields[options.grouplist.index('outputs')]

    ni = len(inputs)
    nh = options.hidden
    no = len(outputs)
    netname = "nn_{0}_{1}_{2}".format(ni, nh, no)
    modulename = "lib{0}{1}".format(netname, ext)
    fullmodelname = os.path.join(savedir, modulename)
    return fullmodelname

def _getCompiledModuleNN(options, dataframe=None, ext=None, 
        outfile=sys.stdout):  #forceCompile=False, 
    """Fournit un modèle compilé defini par les paramètres de options.
    On definit le nom du fichier recherché, puis on recherche s'il existe.
    S'il n'existe pas, il est crée.
    Ce modèle créé est générique. Aucun nom d'entrée ou de sqortie, et aucun 
    dimensionnement de la mémoire pour les données
    """
    if ext is None:
        ext = libExtension()
    doprinttime = options.verbose
    savedir = options.folder
    if not savedir:
        savedir = options.savedir
    if dataframe:
        inputs = dataframe.fieldsOf('inputs')
        outputs = dataframe.fieldsOf('outputs')
    elif not options.notrain:
        inputs = options.datafields[options.grouplist.index('inputs')]
        outputs = options.datafields[options.grouplist.index('outputs')]
    else:
        inputs = options.testfields[options.grouplist.index('inputs')]
        outputs = options.testfields[options.grouplist.index('outputs')]
    ni = len(inputs)
    nh = options.hidden
    no = len(outputs)
    netname = "nn_{0}_{1}_{2}".format(ni, nh, no)
    modulename = "lib{0}{1}".format(netname, ext)
    fullmodelname = os.path.join(savedir, modulename)
    modeldata = ModelData(input=ni, output=no, hidden=nh, name=netname)
    if not options.modelcreation and os.path.exists(fullmodelname):
        lib, OK = loadModule(fullmodelname, all=True)
        if OK:
            return lib, fullmodelname, modeldata
        lib.__del__()
        lib = None
    if os.path.exists(fullmodelname):
        removemodule(fullmodelname)
    try:
        base = appdatadir("", "nn1")
        tempdir = os.path.join(base, "temp", str(options.keeptemp))
        if options.keeptemp  and (options.keeptemp != 1):
            if outfile and (doprinttime >= 2):
                outfile.write("tempdir: %s\n"% tempdir)#                 cleanDir(tempdir, doprint=True, stoponerror=False, writer=outfile)
        with FanWait('compiling module', outfile, interval=0.2, dotime=doprinttime):
            modulename = createModule(modeldata, savedir, options.keeptemp)
        if savedir:
            modulename = os.path.join(savedir, modulename)
        if options.verbose >= 3 and outfile:
            outfile.write("compiled {0}\n".format(modulename))
    except:
        raise
    lib = loadModule(modulename)
    return lib, modulename, modeldata

def createModule(modeldata, savedir="", keeptemp=0, trainable=True):
    driver = Driver(modeldata=modeldata)
    driver.modelType = 3
    driver.mainModel.mark = "Model created with MonalPy {0}".format(version())
    savingformat = C.SF_DLLTRAIN if trainable else  C.SF_DLL
    modulename = driver.saveModel(savingformat=savingformat, savedir=savedir, 
        tempdir=None, package="", keeptemp=keeptemp, verbose=0, compiler="", 
        forcelib=False, appliname="nn1")
    return modulename

def getExcelFileName(options):
    sourceroot = options.root  
    fname = os.path.join(options.targetfolder, sourceroot)
    return decorfile(fname, options, ".xlsm", indextemplate="(%s)")

def saveFrameToExcel(options, frame, excelwriter, sheetname, actionName):  #, withi ndex=True):
    if (frame is not None) and frame.shape[0] and frame.shape[1] and options.copytype:
        if options.copyexcel:
            frame.to_excel(excelwriter, sheetname)  #, index=with index)
#             sheet = excelwriter.book.get_worksheet_by_name(sheetname)
#             sheet.write_string(0, 0, frame.index.name)
#             val = sheet('A1')
#             if val != frame.index.name:
#                 pass
            excelwriter.book.set_custom_property('{0}count'.format(actionName), frame.shape[0], 'number')
        elif options.copytxtcsv and os.path.exists(options.targetfolder):
            fname = os.path.join(options.targetfolder, '{0}Frame'.format(actionName))
            fname = decorfile(fname, options, ".%s"% options.copytype, indextemplate="(%d)") 
            with open(fname, 'w') as ff:
                ff.write(frame.to_csv(sep=options.sep, decimal=options.decimal))

def CloseExcelwriter(options, excelwriter, vbapath='/data/vbaProject.bin', Sheet=None):
    sourceroot = options.root  
    fname = os.path.join(options.targetfolder, sourceroot)
    excelresult = decorfile(fname, options, ".xlsm", indextemplate="(%s)")
    workbook = excelwriter.book
    workbook.set_size(1490, 1300)
    if vbapath:
        vbaProjectBin = os.path.abspath(vbapath)
        workbook.add_vba_project(vbaProjectBin)
        workbook.set_vba_name('ThisWorkbook')
    enrichUsageSheet(workbook, Sheet, None)
    # ecriture du fichier Excel et fermeture du writer
    excelwriter.save()
    tempres = excelwriter.path
    excelwriter.close()
    os.chmod(tempres, 0o666)
    os.rename(tempres, excelresult)
    return excelresult


def createExcelwriter(options, Frame, sheetname="Sheet 1"):  #, with index=False):
    excelwriter = None
    fname = ""
    if options.copyexcel:
        tempstr = ''.join(choice(ascii_uppercase) for _ in range(8))
        fname = os.path.join(options.targetfolder, "{0}.xlsx".format(tempstr))
        excelwriter = ExcelWriter(fname, engine='xlsxwriter')
        Frame.to_excel(excelwriter, sheetname)  #, index=with index)
    elif options.copytxtcsv and os.path.exists(options.targetfolder):
        fname = os.path.join(options.targetfolder, 'resultFrame')
        fname = decorfile(fname, options, ".{0}".format(options.copytype), indextemplate="(%d)")                    
        with open(fname, 'w') as ff:
            ff.write(Frame.to_csv(sep=options.sep, decimal=options.decimal))
    return fname, excelwriter

def apiCreateExcelAndResultFrame(options, resultFrame, #resultsheetname=None, 
        excelwriter=None, resfile=None, doprint=doNothing):
    tempres = ""
    if options.copyexcel and not excelwriter:
        tempstr = ''.join(choice(ascii_uppercase) for _ in range(8))  # nom aleatoire
        tempres = os.path.join(options.targetfolder, "%s.xlsx"% tempstr)  # nom de fichier excel aleatoire
        excelwriter = ExcelWriter(tempres, engine='xlsxwriter')
    if not resfile:
        resfile = os.path.join(options.savedir, "train.cfg")
        if options.maxrec:
            for maxcount in range(1, options.maxrec+1):
                temp = os.path.join(options.savedir, "train_{0}.cfg".format(maxcount))
                if os.path.exists(temp):
                    resfile = temp
                    break
    if options.notrain:
        sourceroot = options.root  #os.path.splitext(os.path.basename(options.source))[0]
        if not options.savedir:
            options.savedir = os.path.join(options.folder, sourceroot)
            if not os.path.exists(options.savedir):
                os.makedirs(options.savedir)
            else:
                options.savedir = IndexFilename(options.savedir, "_{0}", last=True)            
        if options.savefolder:
            origin = getOrigin(options)
            if origin:  # ici
                dico = getcustomproperties(options.origin, 'Utilities')
                for key, value in dico.items():
                    if key == 'Hidden neurons': 
                        options.hidden = value
                    if key == 'Configuration string': 
                        options.configstr = value
                    if key ==  'Training init count': 
                        options.initcount = value
                    if key == 'Training epochs' : 
                        options.epochs = value
                    if key == 'Test selection threshold' : 
                        if isinstance(value, text_type):
                            value = value[:3]
                        options.leveragethreshold = float(value)
                    if key == 'Best trainings' : 
                        options.maxrec = value
                    if key == 'Random seed' : 
                        options.seed = value
                    if key == "SQL file":
                        options.sqlFileName = value
                    if key == "SQL LOO file":
                        options.sqlLOOFileName = value
                    if key == "Model file":
                        options.modelfile = value
                    if key == "Model LOO file":
                        options.modelloofile = value
        resultFrame = getResultFrame(None, options, resfile)
        if not resultFrame.shape[0]:
            st = "All the trained models are degenerated. The full rank condition is now relaxed\n"
            doprint(st)
            options.extraselect = options.extraselectrelaxed
            resultFrame = getResultFrame(None, options, resfile)
    return excelwriter, resfile, resultFrame, tempres

def _computeTest(options, modeltestframe, IDlist, tablename, pptyname, maxreclist, source, savedir, 
        filename, filetype="", leveragethreshold=1, extraselect="", 
        orderfield="PRESS", verbose=1, debug=0):   #modeluse=USE_LIB, 
    
    if options.mode == "nn":
        return _computeTestNN(options, modeltestframe, IDlist, tablename, 
            pptyname, maxreclist, source, savedir, filename, 
            filetype=filetype, leveragethreshold=leveragethreshold,
            extraselect=extraselect, orderfield=orderfield, 
            verbose=verbose, debug=debug)
    else:
        return _computeTestGM(options, modeltestframe, IDlist, tablename, 
            pptyname, maxreclist, source, savedir, filename, 
            filetype=filetype, leveragethreshold=leveragethreshold,
            extraselect=extraselect, orderfield=orderfield, 
            verbose=verbose, debug=debug)

def _createModelsGM(source, savedir, testFrame, maintitles=[], 
    modeluse=USE_GM_LIB, writer=None, maxworkers=-2, keyTitleList=[], 
    levTitleList=[], verbose=1, debug=0):  
    """Creation des models unitaires (*.so ou ) depuis les noms et smiles 
    contenus dans la base testFrame.
    """
    nametitle, smilestitle, pptyname = maintitles 

    if isinstance(source, str):
        source = np.load(source)
    mess = 'compute modules'
    length = testFrame.shape[0]
    t_create = 0
    t_compute = 0
    t_load = 0
    printtime = False
    
    smilesSerie = testFrame[smilestitle]
    max_workers = maxWorkers(maxworkers)
    with Progress_tqdm(length, desc=mess, nobar=verbose<nobarverb) as update:
        if (max_workers > 1) and not NO_PARALLEL_TEST and not (debug & DEMO_DEBUG_PARALLEL):  # parallel
            with PoolExec(max_workers=max_workers) as executor:
                futures = [executor.submit(computesmile_transfer, 
                    smiles, source, molecule, savedir, writer, False) 
                    for molecule, smiles in smilesSerie.iteritems()]        # iciici
                for indloc, future in enumerate(as_completed(futures)):
                    if update:
                        update(indloc+1)
                    outputs, leverages, molecule = future.result()
                    for keytitle, levtitle, output, leverage in zip(keyTitleList, levTitleList, outputs, leverages):                                                            
                        testFrame.at[molecule, keytitle] = float(output)
                        testFrame.at[molecule, levtitle] = float(leverage)                                                           
        else:
            printtime = True
            for ind, (molecule, smiles) in enumerate(smilesSerie.iteritems()):     # iciici
                if update:
                    update(ind+1)
                
                outputs, leverages, molecule = computesmile_transfer(
                    smiles, source, molecule, savedir, writer, False)
                
                for keytitle, levtitle, output, leverage in zip(keyTitleList, levTitleList, outputs, leverages): 
                    testFrame.at[molecule, keytitle] = float(output)
                    testFrame.at[molecule, levtitle] = float(leverage)
    if printtime:
        print("model creation time", t_create)
        print("model loading time", t_load)
        print("model transfer time", t_compute)  
                             
    return testFrame  #, series

def _computeTestGM(options, modeltestframe, IDlist, tablename, pptyname, 
        maxreclist, source, savedir, filename, filetype="", 
        testrange="", testformat=None, 
        leveragethreshold=1, extraselect="", 
        orderfield="PRESS", verbose=1, debug=0):   
    """Calcul du resultat des tests.
    """
    maintitles = modeltestframe.gettitles()
    nametitle, smilestitle, pptyname = maintitles 
    maxreccount = len(maxreclist)
    maxrec = maxreclist[0]
#     nametitle, smilestitle, pptyname = maintitles 
    testFrameBaseCol = modeltestframe.shape[1]
    testFrame = modeltestframe._frame.copy()
    countfield, cols, richestimated, richtestresidual = getExtraFields(maxreclist, pptyname)
    targetfieldstr = testFrame.columns[-1]
    
    keyList = [_linkstr(estimatedstr, pptyname, ID) for ID in IDlist]
    levList = [_linkstr(leveragestr, pptyname, ID) for ID in IDlist]
    for key, lev in zip(keyList, levList):
        cols.append(key)
        cols.append(lev)
    fullcol = list(testFrame.columns) + cols
    newcol = OrderedDict({val: float('nan') for val in cols})
    testFrame = testFrame.assign(**newcol)
    testFrame = testFrame[fullcol]  # remise en ordre de testFrame

    testFrame = _createModelsGM(source, savedir, testFrame, 
        maintitles=maintitles, keyTitleList=keyList,
         levTitleList=levList, verbose=verbose, debug=debug)   # moduleSerie  modeluse=modeluse, 

    patternlist = FinishTestWithGlobalResults(testFrame, targetfieldstr,
        keyList, levList,  maxreclist, richestimated, richtestresidual, 
        countfield, leveragethreshold)
    
    return testFrame, patternlist, testFrameBaseCol, 0

def getSimpleExtraFields(maxrec, pptyname, fieldlist, cols=[]):
    for ind in range(maxrec):
        for field in fieldlist:
            fieldstr = "{0}({1})".format(_linkstr(field, pptyname), ind)
            cols.append(fieldstr)
    return cols

def getExtraFields(maxreclist, pptyname, cols=[], richestimated=[], richtestresidual=[]):
    countfield = []
    withresidual = len(richtestresidual)
    for maxrecloc in maxreclist:
        if len(maxreclist):
            countfieldstr = "SCount(%d)"% maxrecloc 
            richestimatedstr = "%s(%d)"% (_linkstr(estimatedstr, pptyname), maxrecloc)
        else:
            countfieldstr = "SCount"
            richestimatedstr = _linkstr(estimatedstr, pptyname)
        if withresidual:
            if len(maxreclist):
                richtestresidualstr = "%s(%d)"% (_linkstr(testresidualstr, pptyname), maxrecloc)
            else:
                richtestresidualstr = _linkstr(testresidualstr, pptyname)
            extracol = [richestimatedstr, richtestresidualstr, countfieldstr]
        else:
            richtestresidualstr = ""
            extracol = [richestimatedstr, countfieldstr]
        cols.extend(extracol)
        richestimated.append(richestimatedstr)
        richtestresidual.append(richtestresidualstr)
        countfield.append(countfieldstr)
    return countfield, cols, richestimated, richtestresidual

def FinishTestWithGlobalResults(testFrame, targetfieldstr, keyList, levList, maxreclist, 
    richestimated, richtestresidual, countfield, leveragethreshold=1):
    computeFieldList = [testFrame[key] for key in keyList] 
    leveragesFieldList = [testFrame[key] for key in levList] 
    
    testlist = list(zip(maxreclist, richestimated, richtestresidual, countfield))  #[-1::-1]
    for maxrecloc, richestimatedstr, richtestresidualstr, countfieldstr in testlist:
        patternlist = []
        for index in testFrame.index:
            locpattern = []
            scount = 0
            sum = 0     
            vals = [serie[index] for serie in computeFieldList[:maxrecloc]] 
            levs =  [serie[index] for serie in leveragesFieldList[:maxrecloc]] 
            for val, lev in zip(vals, levs):
                if (lev <= leveragethreshold) and not np.isnan(val):
                    locpattern.append(0)
                    scount += 1
                    sum += val
                else:
                    locpattern.append(1)
            if scount:
                valoc = sum / scount
            else:
                valoc = float('nan')
            testFrame.at[index, richestimatedstr] =  valoc
            testFrame.at[index, richtestresidualstr] = valoc - testFrame.at[index, targetfieldstr]   #testFrame.ix[index][1]       
            testFrame.at[index, countfieldstr] = int(scount)
        patternlist.append(locpattern)
    testFrame[countfieldstr] = testFrame[countfieldstr].astype(np.int)
    return patternlist

def _computeTestNN(options, modeltestframe, IDlist, tablename, pptyname, 
        maxreclist, source, savedir, filename, filetype="", 
        leveragethreshold=1, extraselect="", orderfield="PRESS", 
        verbose=1, debug=0):   #modeluse=USE_LIB, 
    """Calcul du resultat des tests.
    """
    maintitles = modeltestframe.gettitles()
    maxreccount = len(maxreclist)
    maxrec = maxreclist[0]
    nametitle = maintitles[0]
    pptyname = maintitles[-1]
    inputtitles = maintitles[1:-1]
    testFrameBaseCol = modeltestframe.shape[1]
    testFrame = modeltestframe._frame.copy()
    propertyfield = testFrame.columns[-1]
    countfield, cols, richestimated, richtestresidual = getExtraFields(maxreclist, pptyname)
    targetfieldstr = testFrame.columns[-1]
    
    keyList = [_linkstr(estimatedstr, pptyname, ID) for ID in IDlist]
    levList = [_linkstr(leveragestr, pptyname, ID) for ID in IDlist]
    for key, lev in zip(keyList, levList):
        cols.append(key)
        cols.append(lev)
    fullcol = list(testFrame.columns) + cols
    newcol = OrderedDict({val: float('nan') for val in cols})
    testFrame = testFrame.assign(**newcol)
    testFrame = testFrame[fullcol]  # remise en ordre de testFrame

    testFrame, inputcount = fillTestFrameNN(options, source, savedir, testFrame, 
        maintitles=maintitles, keyTitleList=keyList, levTitleList=levList, 
        verbose=verbose, debug=debug)   # moduleSerie  modeluse=modeluse, firstcolcount=testFrameBaseCol, 

    patternlist = FinishTestWithGlobalResults(testFrame, targetfieldstr, keyList, levList, 
        maxreclist, richestimated, richtestresidual, countfield, 
        leveragethreshold)
    
    
    return testFrame, patternlist, testFrameBaseCol, inputcount
      
def fillTestFrameNN(options, source, savedir, testFrame, maintitles=[], 
    modeluse=False, writer=None, keyTitleList=[], 
    levTitleList=[], verbose=1, debug=0):  #firstcolcount=0, 
    
    drivermodel, _, _ = _getCompiledModuleNN(options)  #, config, testFrame
    drivermodel.loadFromDict(source)
    options.paramCount = drivermodel.paramCount

    ni = drivermodel.inputCount
    mess = "compute test"
    with Progress_tqdm(len(testFrame.index), desc=mess, nobar=verbose<nobarverb) as update:
        for ind, (frameindex, row) in enumerate(testFrame.iterrows()):
            try:
                inputs = np.asarray(row[0: ni], np.double)
            except ValueError:  # python 2.x
                inputs = np.asarray(row[1: ni+1], np.double)
            outlevlist = drivermodel.transferleverage(inputs, 'extra')
            for (out, lev), outstr, levstr in zip(outlevlist, keyTitleList, levTitleList):
                testFrame.at[frameindex, outstr] = out
                testFrame.at[frameindex, levstr] = lev
            if update:
                update(ind+1)
    return testFrame, ni

def _createModelsLOOGM(source, savedir, testFrame, maintitles=[],
    keyresult="", keyLOOresult="", LOOkeys = [], writer=None, 
    maxworkers=-2, verbose=1, mode="nn", debug=0):  #modeluse=USE_LIB, 
    """Creation des models unitaires (*.so ou ) depuis les noms et smiles 
    contenus dans la base testFrame.
    """
    nametitle, smilestitle, pptyname = maintitles 
    smilesSerie = testFrame[smilestitle]
    inputtitles = []

    if isinstance(source, str):
        source = np.load(source)
    mess = 'compute modules'
    t_create = 0
    t_compute = 0
    t_load = 0
    printtime = False
    
    max_workers = maxWorkers(maxworkers)
    
    # A revoir dans le cas de mode = "nn"
    
    with Progress_tqdm(len(testFrame.index), desc=mess, nobar=verbose<nobarverb) as update:
        if  (max_workers > 1) and not NO_PARALLEL_TEST and not (debug & DEMO_DEBUG_PARALLEL):  # parallel
            with PoolExec(max_workers=max_workers) as executor:
                futures = [executor.submit(computesmile_transferLOO, 
                    index, smiles, source, molecule, savedir, writer, False) 
                    for index, (molecule, smiles) in enumerate(smilesSerie.items())]
                for indloc, future in enumerate(as_completed(futures)):
                    if update:
                        update(indloc+1)
                    indLOO, output, outputs, molecule = future.result()
                    #LOOPred = float(outputs[indLOO])
                    testFrame.at[molecule, keyresult] = float(output)
#                     testFrame.set_value(molecule, keyresult, float(output))
                    mean = 0.0
                    for key, value in zip(LOOkeys, outputs):
                        val = float(value)
                        mean += val
                        testFrame.at[molecule, key] = val
#                         testFrame.set_value(molecule, key, val)
                    mean = mean / len(LOOkeys)
                    testFrame.at[molecule, keyLOOresult] = mean
#                     testFrame.set_value(molecule, keyLOOresult, mean)
        else:
            printtime = True
            for ind, (molecule, smiles) in enumerate(smilesSerie.items()):
                if update:
                    update(ind+1)
                
                indLOO, output, outputs, molecule = computesmile_transferLOO(
                    ind, smiles, source, molecule, savedir, writer, False)
                
                #LOOPred = float(outputs[indLOO])
                testFrame.at[molecule, keyresult] = float(output)
#                 testFrame.set_value(molecule, keyresult, float(output))
                mean = 0.0
                for key, value in zip(LOOkeys, outputs):
                    val = float(value)
                    mean += val
                    testFrame.at[molecule, key] = val
#                     testFrame.set_value(molecule, key, val)
                mean = mean / len(LOOkeys)
                testFrame.at[molecule, keyLOOresult] = mean
#                 testFrame.set_value(molecule, keyLOOresult, mean)
    if printtime:
        print("model creation time", t_create)
        print("model loading time", t_load)
        print("model transfer time", t_compute)  
                             
    return testFrame  #, series

def computesmile_transfer(smile, source, molecule, savedir, writer, givetime): 
    drivermodel, _, molecule, _ = computeSmile(smile, source=source, 
        molecule=molecule, modeldir=savedir, modeluse=USE_NO_LIB, moduletype='', 
        writer=writer, givetime=givetime)
    outputs, leverages = drivermodel.transferEx()  #original=True
    return outputs, leverages, molecule

def computesmile_transferLOO(index, smile, source, molecule, savedir, writer, givetime): 
    drivermodel, _, molecule, _ = computeSmile(smile, source=source, 
        molecule=molecule, modeldir=savedir, modeluse=USE_NO_LIB, moduletype='', 
        writer=writer, givetime=givetime)
    output, outputs = drivermodel.transferExtra()  #original=True
    return index, output, outputs, molecule

def computesmile_transferBS(index, smile, source, molecule, savedir, writer, givetime): 
    drivermodel, _, molecule, _ = computeSmile(smile, source=source, 
        molecule=molecule, modeldir=savedir, modeluse=USE_NO_LIB, moduletype='', 
        writer=writer, givetime=givetime)
    drivermodel.confidenceLevel = 0.95
    output, output95p, output95m, outputs = drivermodel.transferExtraCI()  #original=True
    return index, output, output95p, output95m, outputs, molecule

def _computeLOOTest(options, modeltestframe, tablename, pptyname, datacount, source, #dbConnect, 
        savedir, filename, filetype="", testrange="", testformat=None, 
        leveragethreshold=1, extraselect="", 
        orderfield="PRESS", verbose=1, debug=0):   
    
    if options.mode == 'nn':
        return _computeLOOTestNN(options, modeltestframe, tablename, 
        pptyname, datacount, source, savedir, filename, filetype, 
        testrange, testformat, leveragethreshold, extraselect, 
        orderfield, verbose, debug)
    
    else:
        return _computeLOOTestGM(options, modeltestframe, tablename, 
        pptyname, datacount, source, savedir, filename, filetype, 
        testrange, testformat, leveragethreshold, extraselect, 
        orderfield, verbose, debug)

def _computeLOOTestNN(options, modeltestframe, tablename, pptyname, datacount, source, #dbConnect, 
        savedir, filename, filetype="", testrange="", testformat=None, 
        leveragethreshold=1, extraselect="", 
        orderfield="PRESS", verbose=1, debug=0):   
    """Calcul du resultat des tests avec LOO.
    """
    maintitles = modeltestframe.gettitles()
    pptyname = maintitles[-1]
    testFrameBaseCol = modeltestframe.shape[1]
    testFrame = modeltestframe._frame.copy()

    keyList = [_linkstr(estimatedstr, pptyname, ID) for ID in range(options.loomaxrec)]
    levList = [_linkstr(leveragestr, pptyname, ID) for ID in range(options.loomaxrec)]
    cols = []
    for key, lev in zip(keyList, levList):
        cols.append(key)
        cols.append(lev)
    fullcol = list(testFrame.columns) + cols
    newcol = OrderedDict({val: float('nan') for val in cols})
    testFrame = modeltestframe.assign(**newcol)
    testFrame = testFrame[fullcol]  # remise en ordre de testFrame
 
    testFrame, inputcount = fillLOOTestFrameNN(options, source, savedir, testFrame, 
        maintitles=maintitles, keyTitleList=keyList, levTitleList=levList, 
        verbose=verbose, debug=debug)   # moduleSerie  modeluse=modeluse, firstcolcount=testFrameBaseCol, 
# 
#     patternlist = FinishTestWithGlobalResults(testFrame, targetfieldstr, keyList, levList, 
#         maxreclist, richestimated, richtestresidual, countfield, 
#         leveragethreshold)
#     
    return testFrame, testFrameBaseCol, inputcount

def fillLOOTestFrameNN(options, source, savedir, testFrame, maintitles=[], 
    modeluse=False, writer=None, keyTitleList=[], 
    levTitleList=[], verbose=1, debug=0):  #firstcolcount=0, 
    
    drivermodel, _, _ = _getCompiledModuleNN(options)  #, config, testFrame
    ni = drivermodel.inputCount
    if ni:
        try:
            inputnorm = source["inputnorm"]
        except KeyError:
            inputnorm = source['root']["inputnorm"]
        if isinstance(inputnorm, text_type):
            inputnorm_a = inputnorm.split(';')
            inputnorm = []
            for val in inputnorm_a:
                normloc = []
                if isinstance(val, text_type) and (val.startswith('[') and (val.endswith(']'))):
                    val2 = val[1:-1].split(' ')
                else:
                    val2 = val
                normloc = [val3 for val3 in val2 if val3 != ""]
                inputnorm.append(normloc)                            
        drivermodel.inputnorm = np.asarray(inputnorm)
    try:
        outputnorm = source["outputnorm"]
    except KeyError:
        outputnorm = source['root']["outputnorm"]
    if isinstance(outputnorm, text_type):
        outputnorm_a = outputnorm.split(';')
        outputnorm = []
        if len(outputnorm_a) > 1 and not isFloat(outputnorm_a[0]):
            for val in outputnorm_a:
                normloc = []
                if isinstance(val, text_type) and (val.startswith('[') and (val.endswith(']'))):
                    val2 = val[1:-1].split(' ')
                else:
                    val2 = val
                normloc = [val3 for val3 in val2 if val3 != ""]
                outputnorm.append(normloc)  
        else:
            val = outputnorm_a
            if isinstance(val, list) and len(val) == 2:
                outputnorm = [float(vala) for vala in val]
            elif isinstance(val, text_type) and (val.startswith('[') and (val.endswith(']'))):
                val2 = val[1:-1].split(' ')
                outputnorm = [val3 for val3 in val2 if val3 != ""]
            else:
                val2 = val[1:-1].split(' ')
                outputnorm = [float(vala) for vala in val2]
    drivermodel.outputnorm = np.asarray(outputnorm)
    
    options.paramCount = drivermodel.paramCount
    weights = source['extraweights']
    dispersions = source['extradispersion']
    indexex = source['indexes']
    modeldict = source['model']
    try:
        pptyname = source['propertyname']
    except KeyError:
        pptyname = source['root']['propertyname']
    drivermodel.extraweights = weights
    drivermodel.extradispersions = [np.asarray(disp.flat, np.double) for disp in dispersions]   

    ni = drivermodel.inputCount
    mess = "compute test"
    with Progress_tqdm(len(testFrame.index), desc=mess, nobar=verbose<nobarverb) as update:
        for ind, (frameindex, row) in enumerate(testFrame.iterrows()):
            try:
                inputs = np.asarray(row[0: ni], np.double)
            except ValueError:  # python 2.x
                inputs = np.asarray(row[1: ni+1], np.double)
            outlevlist = drivermodel.transferleverage(inputs, 'extra')
            for (out, lev), outstr, levstr in zip(outlevlist, keyTitleList, levTitleList):
                testFrame.at[frameindex, outstr] = out
                testFrame.at[frameindex, levstr] = lev
            update(ind+1)
    return testFrame, ni

def _computeLOOTestGM(options, modeltestframe, tablename, pptyname, datacount, source, #dbConnect, 
        savedir, filename, filetype="", testrange="", testformat=None, 
        leveragethreshold=1, extraselect="", 
        orderfield="PRESS", verbose=1, debug=0):   
    """Calcul du resultat des tests avec LOO.
    """
    maintitles = modeltestframe.gettitles()
    patternlist = []
    if options.mode == 'gm':
        nametitle, smilestitle, pptyname = maintitles 
    else:
        nametitle = maintitles[0]
        pptyname = maintitles[-1]
        inputtitles = maintitles[1:-1]
    reverse = orderfield in C.TCR_MAXIMIZE   
    testFrameBaseCol = modeltestframe.shape[1]
    testFrame = modeltestframe._frame.copy()
    cols = []
    richestimated = []
    countfield = []
    resKey = _linkstr(estimatedstr, pptyname)
    resLOOKey = "LOO_%s"% (_linkstr(estimatedstr, pptyname))
    cols = [resKey, resLOOKey]
    baselen = datacount
    for looindex in range(baselen):
        fieldstr = "LOO_%s_%d"% (_linkstr(estimatedstr, pptyname), looindex)
        richestimated.append(fieldstr)
    cols.extend(richestimated)
    fullcol = list(testFrame.columns) + cols
    newcol = OrderedDict({val: float('nan') for val in cols})
    testFrame = testFrame.assign(**newcol)
    testFrame = testFrame[fullcol]  # remise en ordre de testFrame

    testFrame = _createModelsLOOGM(source, savedir, testFrame, 
        maintitles=maintitles, keyresult=resKey, keyLOOresult=resLOOKey, 
        LOOkeys= richestimated, verbose=verbose, mode=options.mode, debug=debug)   # moduleSerie  modeluse=modeluse, 
 
    return testFrame, patternlist, testFrameBaseCol
      
def _createModelsBS(source, savedir, testFrame, maintitles=[], 
    keyresults=[], keyBSresults=[], BSkeys = [], writer=None, 
    maxworkers=-2, verbose=1, debug=0):  #modeluse=USE_LIB, 
    """Creation des models unitaires (*.so ou ) depuis les noms et smiles 
    contenus dans la base testFrame.
    """
    nametitle, smilestitle, pptyname = maintitles 

    if isinstance(source, str):
        source = np.load(source)
    mess = 'compute modules'
    t_create = 0
    t_compute = 0
    t_load = 0
    printtime = False
    extrasize = source['extraweights'].shape[0]
    smilesSerie = testFrame[smilestitle]
    max_workers = maxWorkers(maxworkers)
    with Progress_tqdm(len(testFrame.index), desc=mess, nobar=verbose<nobarverb) as update:
        if (max_workers > 1) and not NO_PARALLEL_TEST and not (debug & DEMO_DEBUG_PARALLEL):  # parallel
            with PoolExec(max_workers=max_workers) as executor:
                futures = [executor.submit(computesmile_transferBS, 
                    index, smiles, source, molecule, savedir, writer, False) 
                    for index, (molecule, smiles) in enumerate(smilesSerie.items())]
                for indloc, future in enumerate(as_completed(futures)):
                    if update:
                        update(indloc+1)
                    _, output, output95p, output95m, outputs, molecule = future.result()
                    testFrame.at[molecule, keyresults[0]] = output
                    testFrame.at[molecule, keyresults[1]] = output95m
                    testFrame.at[molecule, keyresults[2]] = output95p
#                     testFrame.set_value(molecule, keyresults[0], output)
#                     testFrame.set_value(molecule, keyresults[1], output95m)
#                     testFrame.set_value(molecule, keyresults[2], output95p)
                    for key, value in zip(BSkeys, outputs):
                        val = float(value)
                        testFrame.at[molecule, key] = val
#                         testFrame.set_value(molecule, key, val)
                    mean = np.mean(outputs)
                    min95, max95 = np.percentile(outputs, (2.5, 97.5))
                    #mean / len(BSkeys)
                    testFrame.at[molecule, keyBSresults[0]] = mean
                    testFrame.at[molecule, keyBSresults[1]] = min95
                    testFrame.at[molecule, keyBSresults[2]] = max95
#                     testFrame.set_value(molecule, keyBSresults[0], mean)
#                     testFrame.set_value(molecule, keyBSresults[1], min95)
#                     testFrame.set_value(molecule, keyBSresults[2], max95)
        else:
            printtime = True
            for ind, (molecule, smiles) in enumerate(smilesSerie.items()):
                if update:
                    update(ind+1)
                
                _, output, output95p, output95m, outputs, molecule = computesmile_transferBS(
                    ind, smiles, source, molecule, savedir, writer, False)
                
                testFrame.at[molecule, keyresults[0]] = output
                testFrame.at[molecule, keyresults[1]] = output95m
                testFrame.at[molecule, keyresults[2]] = output95p
#                 testFrame.set_value(molecule, keyresults[0], output)
#                 testFrame.set_value(molecule, keyresults[1], output95m)
#                 testFrame.set_value(molecule, keyresults[2], output95p)
                mean = 0.0
                for key, value in zip(BSkeys, outputs):
                    val = float(value)
                    mean += val
                    testFrame.at[molecule, key] = val
#                     testFrame.set_value(molecule, key, val)
                mean = mean / len(BSkeys)
                min95, max95 = np.percentile(outputs, (2.5, 97.5))
                testFrame.at[molecule, keyBSresults[0]] = mean
                testFrame.at[molecule, keyBSresults[1]] = min95
                testFrame.at[molecule, keyBSresults[2]] = max95
#                 testFrame.set_value(molecule, keyBSresults[0], mean)
#                 testFrame.set_value(molecule, keyBSresults[1], min95)
#                 testFrame.set_value(molecule, keyBSresults[2], max95)
    if printtime:
        print("model creation time", t_create)
        print("model loading time", t_load)
        print("model transfer time", t_compute) 
                             
    return testFrame  #, series

def _computeBSTest(options, modeltestframe, tablename, pptyname, bscount, source, savedir, #dbConnect, 
        filename, filetype="", testrange="", testformat=None, 
        leveragethreshold=1, extraselect="", 
        orderfield="PRESS", verbose=1, debug=0):   #modeluse=USE_LIB, 
    """Calcul du resultat des tests avec LOO.
    """
    maintitles = modeltestframe.gettitles()
    patternlist = []
    if options.mode == 'gm':
        nametitle, smilestitle, pptyname = maintitles 
    else:
        nametitle = maintitles[0]
        pptyname = maintitles[-1]
        inputtitles = maintitles[1:-1]
#     nametitle, smilestitle, pptyname = maintitles 
    reverse = orderfield in C.TCR_MAXIMIZE   
#     testFrame = getFrame(filename, filetype=filetype, datarange=testrange, 
#                     datafields=testformat, indexfield=nametitle)  #indexfield
#     _, testFrameBaseCol = testFrame.shape
    testFrameBaseCol = modeltestframe.shape[1]
    testFrame = modeltestframe._frame.copy()
    #cols = []
    richestimated = []
    #countfield = []
    estimatedfield = _linkstr(estimatedstr, pptyname)
    estimatedfieldM = _linkstr(estimatedfield, "CI95", linker="-")
    estimatedfieldP = _linkstr(estimatedfield, "CI95", linker="+")
    keyresults = [estimatedfield, estimatedfieldM, estimatedfieldP]
    meanBS = _linkstr("BS", meanstr, pptyname)
    meanBSmin = _linkstr(meanBS, "min95")
    meanBSmax = _linkstr(meanBS, "max95")
    keyBSresults = [meanBS, meanBSmin, meanBSmax]
    cols = keyresults + keyBSresults
    for looindex in range(bscount):
        fieldstr = "BS_%s_%d"% (_linkstr(estimatedstr, pptyname), looindex)
        richestimated.append(fieldstr)
    cols.extend(richestimated)
    fullcol = list(testFrame.columns) + cols
    newcol = OrderedDict({val: float('nan') for val in cols})
    testFrame = testFrame.assign(**newcol)
    testFrame = testFrame[fullcol]  # remise en ordre de testFrame

    testFrame = _createModelsBS(source, savedir, testFrame, 
        maintitles=maintitles, keyresults=keyresults, keyBSresults=keyBSresults, 
        BSkeys= richestimated, verbose=verbose, debug=debug)   # moduleSerie  modeluse=modeluse, 
 
    return testFrame, patternlist, testFrameBaseCol

def getOrigin(options):
    cond = not hasattr(options, 'origin') or not options.origin
    if cond and options.savefolder and os.path.isdir(options.savefolder):
        options.origin = options.savefolder
    if options.origin:
        if os.path.isdir(options.origin):
            origin = None
            root, _, files = next(os.walk(options.origin))
            cfgfiles = [val for val in files if val.endswith(".cfg")]
            for val in cfgfiles:
                filename = os.path.join(root, val)
                config = defaultedConfigParser(filename)
                if config.has_option('training', 'excelresult'):
                    origin = config.get('training', 'excelresult')
                    break
            if origin:
                options.origin = origin
        elif not os.path.exists(options.origin) and os.path.exists(options.targetfolder):
            options.origin = os.path.join(options.targetfolder, options.origin)
    return options.origin
      
def apidemoCreateExcelAndResultFrame(options, resultFrame, 
        resultsheetname=None, excelwriter=None, startswithtest=False, 
        resfile=None, doprint=doNothing):  #outfile=None, wit hindex=False, 
    tempres = ""
    if options.copyexcel and not excelwriter:
        tempstr = ''.join(choice(ascii_uppercase) for _ in range(8))  # nom aleatoire
        tempres = os.path.join(options.targetfolder, "%s.xlsx"% tempstr)  # nom de fichier excel aleatoire
        excelwriter = ExcelWriter(tempres, engine='xlsxwriter')
    if startswithtest:
        sourceroot = options.root  #os.path.splitext(os.path.basename(options.source))[0]
        if not options.savedir:
            if options.savefolder:
                if options.origin:  # ici
                    dico = getcustomproperties(options.origin, 'Utilities')
                    options.hidden = dico['Hidden neurons']
                    options.configstr = dico['Configuration string']
                    options.initcount = dico['Training init count']
                    options.epochs = dico['Training epochs']
                    options.leveragethreshold = dico['Test selection threshold']
                    options.maxrec = dico['Best trainings']
                    options.seed = dico['Random seed']
                options.savedir = options.savefolder
            else:
                options.savedir = os.path.join(options.folder, sourceroot)
                if not os.path.exists(options.savedir):
                    os.makedirs(options.savedir)
                else:
                    options.savedir = IndexFilename(options.savedir, "_{0}", last=True)
        if not resfile:
            resfile = os.path.join(options.savedir, "train.cfg")
            if options.maxrec:
                for maxcount in range(1, options.maxrec+1):
                    temp = os.path.join(options.savedir, "train_{0}.cfg".format(maxcount))
                    if os.path.exists(temp):
                        resfile = temp
                        break
            
        resultFrame = getResultFrame(None, options, resfile)
        if not resultFrame.shape[0]:
            st = "All the trained models are degenerated. The full rank condition is now relaxed\n"
            doprint(st)
            options.extraselect = options.extraselectrelaxed
            resultFrame = getResultFrame(None, options, resfile)
    if (resultFrame is not None) and options.copytype:
        if options.copyexcel:
            resultFrame.to_excel(excelwriter, resultsheetname)  #, index=with index)
        elif options.copytxtcsv and os.path.exists(options.targetfolder):
            fname = os.path.join(options.targetfolder, 'resultFrame')
            fname = decorfile(fname, options, ".%s"% options.copytype, indextemplate="(%d)")                    
            with open(fname, 'w') as ff:
                ff.write(resultFrame.to_csv(sep=options.sep, decimal=options.decimal))
                
    return excelwriter, resfile, resultFrame, tempres

def excelRecapitulation(options, resultFrameList, modeldic, gmCustomProperties, doprint):
    recapFrame = getSumaryFrame(resultFrameList, options)
    lst = [val[0] for val in resultFrameList]
    st = strintlist(lst, compact=True, groupdelimiter="--")
    recapSheetName = "Recap_{0}N".format(st) # ici et la
    excelwriter, resfile, recapFrame, tempres = \
        apidemoCreateExcelAndResultFrame(options, recapFrame, recapSheetName, doprint=doprint)
    nametemplate = "summary %dN"
    for hidden, frame, _ in resultFrameList:
        fname = nametemplate %hidden
        frame.to_excel(excelwriter, fname, index=False)
    if options.copytxtcsv:
        pass
    if options.copyexcel:
        sourceroot = "%s_RECAP"% options.root  
        fname = os.path.join(options.targetfolder, sourceroot)
        excelresult = decorfile(fname, options, ".xlsm", indextemplate="(%s)", multihidden=True)
        modeldic["hiddenlist"] = options.multihidden
        modeldic['paramCount'] = [val[2] for val in resultFrameList]
        modeldic['bestCount'] = options.multimaxrec
        if hasattr(options, "configstrMem"):
            modeldic['configmem'] = options.configstrMem
        
        excelwriter = initiateExcelWriter(excelwriter, modeldic, 
            gmCustomProperties, origin=options.savedir, recap=True)

        enrichRecapExcelFile(excelwriter, options, recapSheetName, 
            recapFrame, nametemplate, resultFrameList)
        
        doprint("recapitulation results in file: %s"% (callerView(excelresult, options.caller, options.externpath)))       
        # ajout de la macro autorisant les sauvegardes directes des xlsx meme apres calcul des formules
        workbook = excelwriter.book
        workbook.set_size(1490, 1175)
        workbook.add_vba_project('/data/vbaProject.bin')
        workbook.set_vba_name('ThisWorkbook')
        # ecriture du fichier Excel et fermeture du writer
        excelwriter.close()
        excelwriter.save()
        os.chmod(tempres, 0o666)
        os.rename(tempres, excelresult)

def getSumaryFrame(resultFrameList, options):
    drow0 = max(options.multimaxrec)
    drow = 2 * drow0 
    dcol = 1 + len(options.multihidden)
    
    arr = np.zeros((drow, dcol))
    bsname = "Best selection"
    cols = [bsname]
    for hidden in options.multihidden:
        cols.append("%dN"% hidden)
    sumaryFrame = DataFrame(arr, columns=cols)
    rg = []
    for ind in range(drow0):
        rg.append("avgScore(%d)" % (ind+1))
        rg.append("stdScore(%d)" % (ind+1))
    sumaryFrame[bsname] = rg
    for hidden, frame, _ in resultFrameList:
        avgstdscores = []
        for ind in range(drow0):
            if not ind:
                val = frame["VLOO score"][0]
                avgstdscores.append(val)
                avgstdscores.append(0)
                continue
            lst = frame["VLOO score"][:ind+1]
            val = lst.sum()/(ind+1)
            std = lst.std()
            avgstdscores.append(val)
            avgstdscores.append(std)
        sumaryFrame["%dN"% hidden] = avgstdscores

    return sumaryFrame 

def printresult(options, message, vecind, Pertinence, inputTitles, choices=None, 
        printTitles=True, resultstr="score", doprint=doNothing):
    doprint(message)
    lmax = max([len(val) for val in inputTitles])
    nametitle = "input{0}".format(" "*(lmax-4))
    if printTitles:
        doprint("\t".join(["ind", nametitle, resultstr]))
    addon = [lmax-len(val) for val in inputTitles]
    for ind in vecind:
        if choices is not None:
            choice = choices[ind]
        else:
            choice = True
        if choice:
            prob = "{0:<4.3g}".format(Pertinence[ind])
            supp = " " * addon[ind]
            title = "{0}{1}".format(inputTitles[ind], supp)
            doprint(ind, title, prob, sep="\t")        

# def _DoPreProcToExcel(options, verbose=3):
#     curpreproc = options.preproctype
#     source = DataSource(options.source, options.filetype, options.datarange, 
#         datafmt=options.datafields, titles=True)
#     res = source.getDataArrays(options.datarange, fieldsList=options.datafields, 
#         titles=True, transpose=True)
#     inputTitles = res[-1][options.grouplist.index('inputs')]
#     Inputs = res[options.grouplist.index('inputs')]
#     Outputs = res[options.grouplist.index('outputs')] 
#     perts = []
#     vecinds = []
#     for preproctype in preproctypelist[1:]:
#         options.preproctype = preproctype
#         Pertinence, vecind = doPreProc(options, Inputs, Outputs, inputTitles)  #, doprint=doprint)
#         if Pertinence is None:
#             break
#         perts.append(Pertinence)
#         vecinds.append(vecinds)
# 
#     options.preproctype = curpreproc
#     
# def _preprocAction(options, doprint=doNothing):
#     _DoPreProcToExcel(options)
#     source = DataSource(options.source, options.filetype, options.datarange, 
#         datafmt=options.datafields, titles=True)
#     res = source.getDataArrays(options.datarange, fieldsList=options.datafields, 
#         titles=True, transpose=True)
#     inputTitles = res[-1][options.grouplist.index('inputs')]
#     Inputs = res[options.grouplist.index('inputs')]
#     Outputs = res[options.grouplist.index('outputs')] 
#     dopreproc = options.preproctype in preproctypelist[1:] 
#     res = False 
#     while dopreproc:
#         preproctype = preproctypelist.index(options.preproctype)  
#         mess = "Choose the preprocessor action by its index."
#         printMessage = "Preprocessor action"
#         choicelist = ["No_Action", "linear random probe", "simple 2nd order random probe", "full 2nd order random probe"]
#         preproctype, index = choiceQuestion(mess, choicelist,
#             preproctype, printMessage, returnType=str, doprint=doprint, 
#             extradisplay=True, listindexed=True, forcedefault=options.yes,
#             fulloutput=True)
#         if not index: 
#             return None
#         options.preproctype = preproctypelist[index]
#         Pertinence, vecind = doPreProc(options, Inputs, Outputs, inputTitles, doprint=doprint)
#         if Pertinence is None:
#             return -1
#         doselect = True
#         while doselect:
#             try:
#                 options.pertinencethreshold = valueQuestion("Enter the input selection pertinence", 
#                     options.pertinencethreshold, "Input selection pertinence", 
#                     forcedefault=options.yes, doprint=doprint, 
#                     verbose=options.verbose, returnType=float) 
#             except Exception as err:
#                 doprint(str(err))
#                 return 1
#             res = False            
#             if (0.0 < options.pertinencethreshold < 1.0):
#                 choices = [val < options.pertinencethreshold for val in Pertinence]
#                 if any(choices):
#                     #doprint()
#                     mess = "Following inputs may be removed:"
#                     printresult(options, mess, vecind, Pertinence, 
#                         inputTitles=inputTitles, choices=choices, printTitles=False, 
#                         doprint=doprint)
#                     mess = "Do you accept?"
#                     selcount = 0
#                     for choice in choices:
#                         if not choice:
#                             selcount += 1
#                     OKChoice = vecind[:selcount]
#                     OKChoice.sort()
#                     OKTitles = [inputTitles[val] for val in OKChoice]
#                     st = ", ".join(OKTitles)
#                     printMessage = ""  
#                     res = yesNoQuestion(mess, default='Y', printMessage=printMessage, 
#                         forceyes=options.yes, verbose=options.verbose, 
#                         doprint=doprint)
#                     if res:
#                         inputindex = options.grouplist.index('inputs')
#                         inputini = options.datafields[inputindex]
#                         testinputini = options.testfields[inputindex]
#                         Inputs = [val for ind, val in enumerate(inputini) if ind in OKChoice]
#                         options.groupcount[inputindex] = len(Inputs)
#                         options.datafields[inputindex] = Inputs
#                         if options.test:
#                             Inputs = [val for ind, val in enumerate(testinputini) if ind in OKChoice]
#                             options.testfields[inputindex] = Inputs
#                 if res:
#                     doselect = False
#                 else:
#                     mess = "will you try a new selection threshold ? "
#                     doselect = yesNoQuestion(mess, default='n', printMessage="", 
#                             forceyes=options.yes, verbose=options.verbose, 
#                             doprint=doprint)
#         if res:
#             dopreproc = False
#             doprint("Inputs will be {0}".format(st))
#         else:
#             mess = "will you try a new pre-processing ? "
#             dopreproc = yesNoQuestion(mess, default='y', printMessage="", 
#                     forceyes=options.yes, verbose=options.verbose, 
#                     doprint=doprint)
#     if res:
#         return options
#     return None
# 
# def doPreProc(options, Inputs, Outputs, inputTitles, doprint=doNothing):
#     activepreprocs = preproctypelist[1:]
#     if options.preproctype in activepreprocs:
#         preprocindex = activepreprocs.index(options.preproctype)
#         order2 = preprocindex > 0
#         crossprod = preprocindex == 2
#         options.probecount = valueQuestion("Enter number of random probe tests", 
#             options.probecount, "Probe tests", doprint=doprint, 
#             verbose=options.verbose, forcedefault=options.yes)  #, prefix=prefix)
#         with Progress_tqdm(options.probecount, desc='random probe') as update:
#             Pertinence = randomProbe(Inputs, Outputs, options.probecount, 
#                 seed=options.seed, randomSource='shuffle', order2=order2, 
#                 crossprod=crossprod, progress=update)  #options.preproctype"
#         vecind = orderedIndexes(Pertinence)
#         doprint()
#         message = "Probe results with {0} selection ({1}):".format(options.preproctype, options.probecount)
#         printresult(options, message, vecind, Pertinence, 
#             inputTitles=inputTitles, printTitles=True, doprint=doprint)
#     else:
#         doprint("Random probe analysis failed")
#         Pertinence = vecind = None
#     return Pertinence, vecind

def resamplingTrainModule(module, inittype=C.INIT_START_PARAM, initlist=[], 
        initcount=1, count=0, epochs=0, BStype=RE_NONE, weightsstddev=0.1,
        computeDispersion=False, selected_LOO=None, LOOcriterion=-1,
        callBack=None, onReturnResult=None, seed=None):
    """Launching a special training session. Special may mean Leave-One-out or Bootstrap.
    Parameters:
    
        - module -> In memory training module.
        
        - inittype ->  . Default INIT_START_PARAM
        
            Available:
            
            - INIT_START_PARAM -> Initialization with the parameters of the starting train process
            
            - INIT_END_PARAM -> Initialization with the parameters at the end of the training process
            
            - INIT_RANDOM -> Random initialization.
        
        - initlist -> Rekated to super training.ƒ
            Initialization parameters list. Each item of this list is 
            a tuple of at least 4 elements. Element 2 is used with 
            INIT_END_PARAM inittype, and element 3 is used with INIT_START_PARAM 
            inittype. Default []
        
        - inicount -> Number of initialization for Leave-One-out. Default 1
        
        - count -> Number of Bootstrap resampling. Meaningless for Leave-One-out. Default 0
        
        - epochs -> Training epochs. Default 0
         
        - BStype -> Resampling type. Default RE_NONE
        
            Available:
            - RE_NONE -> no resampling
            
            - RE_BS_STD -> standard Bootstrap.
            
            - RE_BS_RESIDU -> residual Bootstrap.
            
            - RE_LOO -> Leave-One-Out.

        - computeDispersion -> Compute leverages and dispersion matrix. Default False
         
        - selected_LOO -> Debug. With serial training only. List of selected initialization in training base list. Default None
        
        - LOOcriterion -> selection criterion for LOO result. Default CRITER_PRESS
        
            Available: 
            
            - CRITER_STDDEV -> minimum standard deviation 
            
            - CRITER_PRESS -> minimum PRESS
            
            - CRITER_LEV -> minimum pseudo-leverage
        
        - callBack -> Follow up callback function. Default None
    
    return
    
        - loccount -> Number of local training performed.
        
    Constants are defined in module monal.monalconst
    """

    assert(isinstance(module, DriverLib))
    if BStype == RE_LOO:
        res = module.trainLOO(inittype=inittype, initlist=initlist, 
            initcount=initcount, weightsstddev=weightsstddev, epochs=epochs, 
            selected_LOO=selected_LOO, LOOcriterion=LOOcriterion, 
            callback=callBack, onReturnResult=onReturnResult, trainstyle=0,
            seed=seed)  #, parallel=False
    elif BStype == RE_SUPER:
        res = module.trainSuper(inittype=inittype, initlist=initlist, 
            initcount=initcount, weightsstddev=weightsstddev, BScount=count, 
            epochs=epochs, selected_LOO=selected_LOO, callback=callBack, 
            onReturnResult=onReturnResult, trainstyle=0, seed=seed)
    else:
        res = module.trainBS(inittype=inittype, initlist=initlist, 
            initcount=initcount, weightsstddev=weightsstddev, BScount=count, 
            epochs=epochs, BStype=BStype, selected_LOO=selected_LOO, 
            LOOcriterion=LOOcriterion, callback=callBack, 
            onReturnResult=onReturnResult, trainstyle=0, seed=seed)
    # mettre trainstyle=0
    return res
  
def getdataiterator(dataframe):
    for row in dataframe.iterrows():
        yield row

def createTrainingModule(options, dataframe, config, outputdir="", 
        originbase="", unitfilename="", progress=None, keeptemp=0,
        compiler="", verbose=0, doprinttime=False, debug=0):
    if options.mode == "gm":
        lib, fullmodname, modeldata = _createTrainingModuleGM(options, dataframe, 
            config, outputdir=outputdir, originbase=originbase, 
            unitfilename=unitfilename, progress=progress, 
            keeptemp=keeptemp, compiler=compiler, verbose=verbose, 
            doprinttime=doprinttime, debug=debug)
    else:
        lib, fullmodname, modeldata = _getCompiledModuleNN(options, dataframe)
    return lib, fullmodname, modeldata

def _createTrainingModuleGM(options, dataframe, config, outputdir="", 
        originbase="", unitfilename="", progress=None, keeptemp=0,
        compiler="", verbose=0, doprinttime=False, debug=0):
    """Create a module fore training from a data frame.
    
    parameters:    
     - dataiterator -> data broker
     - config -> 
     - modulename -> name to be given to the training module
     - outputdir -> directory for output
     - originbase -> name of the original data base
     - unitfilename -> name of the atomic file name.
     - progress -> process follow-up procedure.
    
    Return the created module.
    """
    updateConfigFromConfigstr(options.configstr, config)
    
    tempdir = gmp.getSourceSaveDir(keeptemp, basedir=options.savedir)
#     if (options.debug & DEMO_DEBUG_MODEL) and options.keeptemp:  # 
#         tempdir = os.path.join(options.savedir, "temp", options.keeptemp)
#         if os.path.exists(tempdir):
#             shutil.rmtree(tempdir, ignore_errors=True)
    modulename = getModelBase(config, fullconfig=True)
    locmodel = "lib{0}{1}".format(modulename.lower(), libExtension())
    fullmodelname = os.path.join(options.savedir, locmodel)
    if options.debug & DEMO_DEBUG_MODEL:
        print('tempdir', tempdir)
        print('modulename', fullmodelname)
    if not options.modelcreation and os.path.exists(fullmodelname):
        lib, OK = loadModule(fullmodelname, all=True)
        modcount = lib.modelCount
        Ok = OK and ((modcount < 0) or (modcount == dataframe.shape[0]))
        if OK:
            return lib, fullmodelname, None
        else:   
            lib.__del__()
            lib = None
    if not originbase and config and config.has_option("general", "root"):
        originbase = config.get("general", "root")
    hidden = options.hidden
    if config:
        config.set("model", "hidden", str(hidden))
    writer = sys.stdout if verbose >= 2 else None
    if not outputdir:
        outputdir = options.savedir
    module, _ = gmp.createmodeltrainingbase(
        keeptemp=keeptemp,
        tempdir=tempdir,
        iterator=dataframe.iterData(), 
        config=config,
        hidden=hidden,
        originbase=originbase,
        outputdir=outputdir, 
        modulename=modulename,          
        savingformat=C.SF_CPYTHON,
        moduletype="dll",
        unitfilename=unitfilename,
        progress=progress,
        compiler=compiler,
        docreatefolder=False,
        writer=writer,
        configstr=options.configstr,
        doprinttime=doprinttime, 
        debug=options.debug)
    if not os.path.exists(module):
        raise Exception("Error creating module %s"% module) 
    lib, OK = loadModule(module, all=True)
    return lib, module, None

def defaultCfg(mode="nn", addtrain=True):   
    """Creation of the default configuration parser.
    
    Parameters:
     - excluded -> sections to exclude
     - mode -> 'nn' or 'gm'
    """
    config = defaultedConfigParser() 
    if not mode in ['nn', 'gm']:
        return config
    sectionlist = ["general", "model", "private"]
    if addtrain:
        sectionlist.insert(2, "training")
    if mode == 'gm':
        sectionlist.insert(2, "connectivity")
        
    for section in sectionlist:
        config.add_section(section)
    if mode == 'gm':
        config.set("general", "fullhydrogen", "False")
        
        config.set("model", "mergeisochiral", "False")
        config.set("model", "mol1", "True")
        config.set("model", "isomeric_algo", "1")
        
        config.set("private", "compactness", "3")
        
        
    config.set("general", "simpledispersion", "False")
    config.set("general", "verbose", "0")
    
    config.set("model", "compiler", "")
    config.set("model", "hidden", "0")
#     config.set("model", "maxneuron", "25")
#     config.set("model", "hiddenmax", "50")
    
    config.set("private", "keeptemp", "")
    config.set("private", "moduletype", "dll")
    return config 

def manageSingleUsage(options, model, outs, levs, stds, students):
    printcond = options is not None and hasattr(options, 'debug') and options.debug & DEMO_DEBUG_USAGE       

    ics = [np.sqrt(lev)*studentvar*stddev for lev, stddev, studentvar in zip(levs, stds, students)]
    extraVLOOs = model.extraVLOO[:len(outs)] if model.extraVLOO is not None else [np.nan for _ in range(outs)]
    #extraVLOOs = extraVLOOs[:len(outs)]

    ar = np.asarray([outs, levs, stds, students, ics, extraVLOOs]).T
    if printcond:
        print('outs len :', len(outs))
        print('levs len :', len(levs))
        print('stds len :', len(stds))
        print('students len :', len(students))
        print('ics len :', len(ics))
        print('extraVLOOs len :', len(extraVLOOs))
    names = ['output', 'leverage', 'stddev', 'student', 'IC', 'VLOO']
    usageFrame = DataFrame(ar, columns=names)
    if printcond:
        print('usageFrame.shape :', usageFrame.shape)
    thres = options.leveragethreshold
    validCount = 0
    todrop = []
    minlev = float('inf')
    indexminlev = -1
    
    # recherche des lev invalides
    for index, val in usageFrame['leverage'].items():
        try:
            val = val.squeeze()
        except: pass
        if val < minlev:
            minlev = val
            indexminlev = index
        if val > thres:
            todrop.append(index)
        else:
            validCount += 1
    if indexminlev in todrop:
        todrop.pop(todrop.index(indexminlev))
    if not validCount:
        print("minimum leverage ( {0} ) overpass the limit ( {1} )".format(minlev, options.leveragethreshold))
        print("only one value wil be kept with leverage {0}".format(minlev))
    elif validCount < len(outs):
        print("only {0}/{1} models will be kept".format(validCount, len(outs))) 
        usageFrame.drop(todrop, inplace=True)
    return usageFrame

def finishMultiUsage(resultFrame, pptyname, basefieldlist, modelNames, 
                     outslist, levslist, icslist, levthres, verbose):
    def getindex(col):
        n1 = col.rfind('(')
        if n1 < 0 :
            return -1
        else:
            tst = col[n1+1:-1]
            try:
                index = int(tst)
            except:
                index = 0
        return index
    
    minslist = []
    maxslist = []
    meanlist = []
    countlist = []
    for outs, ics, levs in zip(outslist, icslist, levslist):
        minlst = []
        maxlst = []
        cumul = 0
        count = 0
        for out, ic, lev in zip(outs, ics, levs):
            ic = ic.squeeze()
            out = out.squeeze()
            lev = lev.squeeze()
            if lev < levthres:
                minlst.append(out - ic)
                maxlst.append(out + ic)
                cumul += out
                count += 1
        countlist.append(count)
        minslist.append(minlst)
        maxslist.append(maxlst)
        if count:
            meanlist.append(cumul / count)
        else:
            meanlist.append(float('nan'))
    
    IDs = list(resultFrame.index)
    for col in resultFrame.columns:
        curindex = getindex(col)
        if col.startswith('mean'):
            for ID, mean in zip(IDs, meanlist):
                resultFrame.at[ID, col] = mean 
        elif col.startswith('SCount'):
            for ID, cnt in zip(IDs, countlist):
                resultFrame.at[ID, col] = cnt 
        elif col.startswith("estimated"):
            for ID, outs in zip(IDs, outslist):
                try:
                    out = outs[curindex]
                    resultFrame.at[ID, col] = out
                except: pass  
        elif col.startswith("min"):
            for ID, mins in zip(IDs, minslist):
                try:
                    min = mins[curindex]
                    resultFrame.at[ID, col] = min 
                except: pass 
        elif col.startswith("max"):
            for ID, maxs in zip(IDs, maxslist):
                try:
                    max = maxs[curindex]
                    resultFrame.at[ID, col] = max  
                except: pass 
        elif col.startswith("leverage"):
            for ID, levs in zip(IDs, levslist):
                try:
                    lev = levs[curindex]
                    resultFrame.at[ID, col] = lev 
                except: pass 
    return resultFrame 

def finishSingleUsage(usageFrame, modelname, smile, inputs, target, 
    inputnames, outputname, leveragethreshold, dsize, verbose=3, verbosexls=0, 
    options=None):
    # usageFrame columns : output', 'leverage', 'stddev', 'student', 'IC', 'VLOO'
    def formattedvalue(value, verb, dsize=0):
        if dsize > 0:
            fmt = "{{0:.{0}f}}".format(dsize)
            return fmt.format(value)
        if not verb:
            return "{0:.2f}".format(value)
        if verb == 1:
            return "{0:.3f}".format(value)
        if verb > 1:
            return "{0:.6f}".format(value)
    outputname = outputname if outputname else "output"
    if target is not None:
        st = "target: {0}".format(formattedvalue(target, verbosexls, dsize))
        st = "{0} {1}".format(outputname, st)
        if modelname:
            st = "{0} {1}".format(modelname, st)
        print(st)
    if verbose >= 3:
        if smile:
            print("smiles {0}".format(smile))
        if inputs is not None and len(inputs) > 1:
            if verbosexls > 1:
                print("\t\t".join(inputnames))
            else:
                print("\t".join(inputnames))
            lst = [formattedvalue(val, verbosexls, dsize) for val in inputs]
            print("\t".join(lst))
    cumul = 0
    valmin = float('inf')
    valmax = -float('inf')
    for ind, row in usageFrame.iterrows(): 
        out = row['output'].squeeze()
        ic = row['IC'].squeeze()
        cumul += out
        valmin = min(valmin, out - ic)
        valmax = max(valmax, out + ic)
    mean = cumul / (ind + 1)
        
    if verbose <= 2:
        st = "estimated {0}".format(formattedvalue(mean, verbosexls, dsize))
        st = "{0} {1}".format(outputname, st)
        print(st)
    elif verbose >= 3:
        st = "estimated: {0} (min: {1}, max: {2})".format(formattedvalue(mean, verbosexls, dsize), formattedvalue(valmin, verbosexls, dsize), formattedvalue(valmax, verbosexls, dsize))
        st = "{0} {1}".format(outputname, st)
        print(st)
    if verbose >= 4:
        st = "leverage threshold {0}".format(leveragethreshold)
        print(st)
        print("model details :")
        if verbose == 3:
            if verbosexls > 1:
                print("{0}\t\t{1}\t\t{2}".format(outputname, "min", "max"))
            else:
                print("{0}\t{1}\t{2}".format(outputname, "min", "max"))
        else:
            if verbosexls > 1:
                print("{0}\t\t{1}\t\t{2}\t\t{3}".format(outputname, "min", "max", "leverage"))
            else:
                print("{0}\t{1}\t{2}\t{3}".format(outputname, "min", "max", "leverage"))
        for ind, row in usageFrame.iterrows():
            out = row['output'].squeeze()
            ic = row['IC'].squeeze()
            outmin = out - ic
            outmax = out + ic
            if verbose == 3:
                st = "{0:.6f}\t{1:.6f} {2:.6f}".format(formattedvalue(out, verbosexls, dsize), formattedvalue(outmin, verbosexls, dsize), formattedvalue(outmax, verbosexls, dsize))
            else:
                lev = row['leverage'].squeeze()
                st = "{0}\t{1}\t{2}\t{3}".format(formattedvalue(out, verbosexls, dsize), formattedvalue(outmin, verbosexls, dsize), formattedvalue(outmax, verbosexls, dsize), formattedvalue(lev, verbosexls, dsize))
            if (target is not None) and ((outmin > target) or (outmax < target)):
                print_(st, file=sys.stderr)
            else:
                print(st)

def prepareUsageAction(options=None, modelfile=None, data=""):
    inputnames = []
    outputnames = []
    datalist = []
    datamode = 'single'
    if modelfile is None:  #
        modelfile = options.origin
    if data is None or data == "":
        data = options.usagedata
    if data is None or data == "":
        data = options.source
        datamode = 'multi'
    if data and data.startswith('@'):
        data = data[1:]
        datamode = 'multi'
    source = getDictFromGmx(modelfile)
    xml = source['xml'] if 'xml' in source.keys() else ""
    xml = xml if not xml.startswith('unknown') else ""
    extracount = 0
    if 'extraweights' in source and source['extraweights'] is not None:
        ewshape = source['extraweights'].shape
        if source['extraweights'].ndim == 2:
            extracount = source['extraweights'].shape[0]
    mode = 'gm' if 'occurence' in source.keys() else 'nn'
    modeldict = source["model"]
    hidden = int(modeldict["hidden"])    
    if 'inputnames' in modeldict and modeldict['inputnames']:
        inputnames = modeldict['inputnames'].split(',')
    if 'outputname' in modeldict:
        outputnames = modeldict["outputname"].split(',')
    ni = len(inputnames)
    no = len(outputnames)
    if options.debug & DEMO_DEBUG_USAGE:
        print('previous grouplist', options.grouplist)
    #fmt = "{0}"
    dsize = -1
    if datamode == "single":
        st = data 
        lst = st.split(";") 
        testlen = len(lst)
        if testlen > 1:
            datalist = []
            for val in lst:
                sublst = val.split(",")
                sublst2 = []
                for subval in sublst:
                    try:
                        subval2 = float(subval)
                    except:
                        subval2 = subval
                    sublst2.append(subval2)
                datalist.append(sublst2)
                dsize = get_decimal_size(val)
        else:   
            datalist = []
            for val in st.split(","):
                try:
                    val2 = float(val)
                except:
                    val2 = val
                datalist.append(val2)
                dsize = get_decimal_size(val2)
            datalist = [datalist]
        if options.grouplist == [] :
            if mode == 'nn':
                if testlen == 3:
                    options.grouplist = ['identifiers', 'inputs', 'outputs']
                elif testlen == 2: 
                    if isinstance(datalist[0][0], str):
                        options.grouplist = ['identifiers', 'inputs']  
                    else:
                        options.grouplist = ['inputs', 'outputs']  
                elif testlen == 1: 
                    options.grouplist = ['inputs'] 
            elif mode == 'gm':
                if testlen == 3: 
                    options.grouplist = ['identifiers', 'smiles', 'outputs'] 
                elif len(datalist) == 1:
                    options.grouplist = ['smiles']
                elif testlen == 2:
                    if isinstance(datalist[1][0], str):
                        options.grouplist = ['identifiers', 'smiles'] 
                    else:
                        options.grouplist = ['smiles', 'outputs'] 
    else:
        pass    
    if 'outputs' in options.grouplist:
        test = datalist[options.grouplist.index('outputs')][0]
        if not isFloat(test):
            datalist = datalist[:-1]
            options.grouplist = options.grouplist[:-1]
    
    grouplist = ['targets' if val == 'outputs' else val  for val in options.grouplist]
    if options.debug & DEMO_DEBUG_USAGE:
        print('datamode', datamode)
        print('mode', mode)
#         print('grouplist', grouplist)
                
    return datamode, data, source, mode, inputnames, outputnames, hidden, datalist, grouplist, extracount, xml, dsize

    
if __name__ == '__main__':
    pass